;
; DragonDos 1.0, Copyright (C) 1982, Dragon Data Ltd.
;
; Disassembled 28/10/2004, P.Harvey-Smith.
;
; Ported to the Dragon Alpha/Professional hardware,
; 29/10/2004 P.Harvey-Smith.
;

		ifp1
		use		dgndefs.asm
		endc

		IFNE	DragonAlpha

* Dragon Alpha has a third PIA at FF24, this is used for
* Drive select / motor control, and provides FIRQ from the
* disk controler.

DPPIADA		EQU		DPPIA2DA
DPPIACRA	EQU		DPPIA2CRA		
DPPIADB		EQU		DPPIA2DB		
DPPIACRB	EQU		DPPIA2CRB

PIADA		EQU		DPPIADA+IO	; Side A Data/DDR
PIACRA		EQU		DPPIACRA+IO	; Side A Control.
PIADB		EQU		DPPIADB+IO	; Side A Data/DDR
PIACRB		EQU		DPPIACRB+IO	; Side A Control.

;WD2797 Floppy disk controler, used in Alpha Note registers in reverse order !
DPCMDREG	EQU		DPCmdRegA		; command/status			
DPTRKREG	EQU		DPTrkRegA		; Track register
DPSECREG	EQU		DPSecRegA		; Sector register
DPDATAREG	EQU		DPDataRegA		; Data register

CMDREG		EQU		DPCMDREG+IO	; command/status			
TRKREG		EQU		DPTRKREG+IO	; Track register
SECREG		EQU		DPSECREG+IO	; Sector register
DATAREG		EQU		DPDATAREG+IO	; Data register

; Disk IO bitmasks

NMIEn    	EQU		NMIEnA
WPCEn    	EQU   	WPCEnA
SDensEn  	EQU   	SDensEnA
MotorOn  	EQU   	MotorOnA 

Drive0		EQU		Drive0A
Drive1		EQU		Drive1A
Drive2		EQU		Drive2A
Drive3		EQU		Drive3A

KnownBits	EQU		Drive0+Drive1+Drive2+Drive3+MotorOn+WPCEn

			ELSE
		
DPPIADA		EQU		DPPIA1DA
DPPIACRA	EQU		DPPIA1CRA		
DPPIADB		EQU		DPPIA1DB		
DPPIACRB	EQU		DPPIA1CRB

PIADA		EQU		DPPIADA+IO	; Side A Data/DDR
PIACRA		EQU		DPPIACRA+IO	; Side A Control.
PIADB		EQU		DPPIADB+IO	; Side A Data/DDR
PIACRB		EQU		DPPIACRB+IO	; Side A Control.

;WD2797 Floppy disk controler, used in DragonDos.
DPCMDREG	EQU		DPCmdRegD		; command/status			
DPTRKREG	EQU		DPTrkRegD		; Track register
DPSECREG	EQU		DPSecRegD		; Sector register
DPDATAREG	EQU		DPDataRegD		; Data register

CMDREG		EQU		DPCMDREG+IO	; command/status			
TRKREG		EQU		DPTRKREG+IO	; Track register
SECREG		EQU		DPSECREG+IO	; Sector register
DATAREG		EQU		DPDATAREG+IO	; Data register

; Disk IO bitmasks

NMIEn    	EQU		NMIEnD
WPCEn    	EQU   	WPCEnD
SDensEn  	EQU   	SDensEnD
MotorOn  	EQU   	MotorOnD

		ENDC

		ORG     $C000

DC000   FCC     /DK/		; Disk cartrage auto-init identifier.

LC002   BRA     LC02A

; Indirect jump table, these are probably the official DragonData entry
; points to be called with jsr [entry]

        FDB     DDosLowLevel		; Low Level disk IO routine
        FDB     $00EA				; Address of data table for low level command
        FDB     DDosValidFilename	; Validate filename & copy to disk block.
        FDB     DDosOpenFile		; Open A file.
        FDB     DDosCreateFile		; Create file (make backup)
        FDB     DDosGetFlen			; Get file length
        FDB     DDosCloseAll		; Close all open files
        FDB     DDosCloseFile		; Close file
        FDB     DDosFRead			; Read data from file
        FDB     DDosFWrite			; Write data to file
        FDB     DDosGetFree			; Get free space on a disk
        FDB     DDosDeleteFile		; Delete a file
        FDB     DDosProtect			; Protect/unprotect file
        FDB     DDosRename			; Rename a file 
        FDB     DDosGetDirEntry		; Get a directory entry
        FDB     DDosFindAndRead		; Find free buffer and read sector
        FDB     DDosSyncDir			; Copy updated sectors from track 20 to 16 (sync direcories)
        FDB     DDosReadAbsSector	; Read absolute sector
        FDB     DDosWriteAbsSector	; Write absolute sector (no verify)

LC02A   LDX     #$0600		; Init dos work area $600-$c00
        TFR     X,Y			; clear all bytes.
LC02F   CLR     ,X+
        LEAY    -1,Y
        BNE     LC02F
        TFR     X,D
        TFR     A,B
        ADDB    #$18
        STB     <$19
        JSR     >$AA87
        LDA     <$BA
        ADDA    #$06
        STA     <$B7
        LDX     #DDE1E		; Init various system areas, including NMI, IRQ, FIRQ vectors.
LC049   LDB     ,X+
        BEQ     LC054
        LDU     ,X++
        JSR     >$B7CC
        BRA     LC049

LC054   LDB     #$20
        STB     $0607
        COM     $0608
        LDX     #$0683
        STX     <$B0
        LDU     #$8B8D
        LDB     #$0A
LC066   STU     ,X++
        DECB
        BNE     LC066
        INC     $060A
        BSR     LC0B8
        LDX     #$015E
        LDY     #DDE95
        LDD     #$137E
LC07A   STB     ,X+
        LDU     ,Y++
        STU     ,X++
        DECA
        BNE     LC07A
        LDX     #$4549
        CMPX    $E000
        LBEQ    $E002
EIEND   LDX     #LC6DF
        STX     <$72
        LDA     #$55
        STA     <$71
        ANDCC   #$AF
        LDX     #$B4B2
        JSR     >BasicPrintStr
        INC     <$EB
        LDX     #$8000
        CLRA
LC0A4   MUL
        LEAX    -1,X
        BNE     LC0A4
        JSR     >LC165
        JSR     >$BA77
        LDX     #DDFBA
        JSR     >BasicPrintStr
        JMP     >$8371

LC0B8   LDA     #$D0
        STA     CMDREG
        LDX     #$0696
        CLR     ,X
        CLR     1,X
        CLR     2,X
        CLR     3,X
        LDX     #$0621
        CLR     ,X
        CLR     6,X
        CLR     12,X
        CLR     $12,X
        CLR     <$F6
        LDX     #$06AB
LC0D9   CLR     ,X+
        CMPX    #$07F3
        BNE     LC0D9
        LDB     #$04
        LDX     #$0634
        LDU     #$0800
LC0E8   CLR     2,X
        STB     4,X
        STU     5,X
        LEAU    $0100,U
        LEAX    7,X
        DECB
        BNE     LC0E8
        RTS

        FCB     $C6
        FCB     $06
        FCB     $8C

LC0FB   LDB     #$05

        FCB     $8C

DoWriteAbsSector   LDB     #$04
LC101   EQU     *+1
        CMPX    #DC603

        FCB     $8C

DoReadAbsSector   
	LDB     #$02
LC106   PSHS    A
        LEAS    -2,S
        CLR     $0600
LC10D   LDA     #$03
        STD     ,S
LC111   BSR     LC162
        BCS     LC11E
        LDB     1,S
        STB     <$EA
        JSR     >DDosLowLevel
        BCC     LC15A
LC11E   CMPB    #$84
        BEQ     LC149
        DEC     ,S
        BEQ     LC13B
        LDB     ,S
        LSRB
        BCC     LC133
        INC     <$EC
        BSR     LC162
        DEC     <$EC
        BRA     LC111

LC133   LDA     <$EC
        BSR     LC165
        STA     <$EC
        BRA     LC111

LC13B   CMPB    #$80
        BNE     LC157
        TST     $0600
        BNE     LC157
        COM     $0600
        BRA     LC153

LC149   LDA     <$EC
        CMPA    #$14
        BNE     LC157
        LDA     #$10
        STA     <$EC
LC153   LDB     1,S
        BRA     LC10D

LC157   ORCC    #$01
LC15A   EQU     *+1
        BRN     LC1BA
        LEAS    2,S
        PULS    A,PC

LC15F   LDB     #$07

        FCB     $8C

LC162   LDB     #$01
LC165   EQU     *+1
        CMPX    #DC600
        STB     <$EA

;
; Disk Low level access.
;

DDosLowLevel   
	PSHS    CC,A,DP,X,Y,U
        ORCC    #$50
        ROR     ,S
        CLR     <$F0
        LDA     <$EA
        CMPA    #$07
        BLS     LC179
        BRA     LC181

LC179   JSR     >LC26E
        BCC     LC18C
        LDB     #$FD

        FCB     $8C

LC181   LDB     #$FC
        ORCC    #$01
        ROL     ,S
        STB     <$F0
        LBRA    LC230

LC18C   LDX     #PIA0CRA
        LDB     #$34
        LDU     #LDFD2
        EXG     U,PC

LC196   LDU     #LDFD2
        EXG     U,PC

LC19B   NOP
        LDB     #$37
        STB     PIACRB
        LDA     #$03
        PSHS    A
        LDA     <$ED
        CMPA    #$12
        BLS     LC1B5
        SUBA    #$12
        LDB     #$02
        ORB     $0606
        STB     $0606
LC1B5   STA     SECREG
LC1BA   EQU     *+2
LC1B8   LDY     <$8A
        LDX     <$EE
        LDB     <$EA
        ASLB
        LDA     #$FF
        TFR     A,DP
        LDU     #DDDD4
        JSR     [B,U]
        STA     <$F0
        BCC     LC1CF
        BRA     LC1FD

LC1CF   ANDA    $0609
        STA     <$F0
        BEQ     LC1E4
        LDA     <$EA
        CMPA    #$07
        BEQ     LC1E0
        DEC     ,S
        BNE     LC1B8
LC1E0   ORCC    #$01
        BRA     LC1FD

LC1E4   TST     $0609
        BPL     LC1FD
        LDA     <$EC
        CMPA    #$14
        BEQ     LC1FA
        CMPA    #$10
        BEQ     LC1FA
        TST     $0608
        ANDCC   #$FE
        BPL     LC1FD
LC1FA   LBSR    LC15F
LC1FD   LEAS    1,S
        ROL     4,S
        LDX     #$069A
        LDB     <$EB
        ABX
        LDA     TRKREG
        CMPA    <$EC
        BEQ     LC21F
        LDB     $0609
        CMPB    #$19
        BNE     LC21F
        LDB     #$FF
        STB     <$F0
        ROR     4,S
        ORCC    #$01
        ROL     4,S
LC21F   STA     ,X
        LDU     #LDFE3
        EXG     U,PC

LC226   LDU     #DDFE6
        EXG     U,PC

		BRN		$C224
		CLR		$0606
;        FCB     $21
;        FCB     $F7
;        FCB     $7F
;        FCB     $06
;        FCB     $06

LC230   CLRB
        PULS    CC,A,DP,X,Y,U
        BCS     LC236
LC235   RTS

LC236   LDB     <$F0
        BEQ     LC235
        BPL     LC25C
        CMPB    #$FC
        BNE     LC244
        LDB     #$A4
        BRA     LC26B

LC244   CMPB    #$FD
        BNE     LC24C
        LDB     #$28
        BRA     LC26B

LC24C   CMPB    #$FE
        BNE     LC254
        LDB     #$80
        BRA     LC26B

LC254   CMPB    #$FF
        BNE     LC269
        LDB     #$82
        BRA     LC26B

LC25C   TFR     B,A
        LDB     #$82
        ROLA
LC261   ADDB    #$02
        ROLA
        TSTA
        BCS     LC26B
        BNE     LC261
LC269   LDB     #$A6
LC26B   ORCC    #$01
        RTS

LC26E   LDA     #$D0
        STA     CMDREG
        LDA     <$EB
        BEQ     LC27C
        DECA
        CMPA    #$03
        BLS     LC27F
LC27C   ORCC    #$01
DC27E   RTS

LC27F   ORA     #$24
        PSHS    A
        LDA     $0607
        ANDA    #$FC
        ORA     ,S+
		
		IFNE	DragonAlpha
		LBSR	AlphaDskCtl
		ELSE
        STA     DSKCTL
		ENDc
		
		STA     $0607
        LDX     #$069A
        LDA     <$EB
        LDA     A,X
        STA     TRKREG
        LDA     #$D2
        STA     $0605
        CLRB
        RTS

LC2A1   CLRA
        STA     >$00EC
        BRA     LC2B9

LC2A7   LDA     >$00EC
        CMPA    DPTrkReg	;<$41	; TRKREG 
        BNE     LC2B5
        CLRA
        STA     $0609
        TFR     A,DP
        RTS

LC2B5   STA     DPDataReg	; <$43 ;DATAREG  		; This is disk data register as DP=$FF
        LDA     #$10
LC2B9   LDB     #$19
        STB     $0609
        LDX     #$069E
        LDB     >$00EB
        ORA     B,X
        STA     DPCmdReg	; <$40 	; CMDREG  
LC2C8   MUL
        MUL
        LEAY    -1,Y
        BNE     LC2C8
        BRA     LC31B

LC2D0   LDA     #$C0
LC2D2   CMPX    #$8688
LC2D3	EQU		LC2D2+1
		LDB     #$3F
        STB     $0609
        LDB     #$05
        ORA     $0606
        STA     DPCmdReg	; <$40 	; CMDREG 
LC2E1   
		LDA     DPPIACRB	; <$23	; PIA1CRB  
 		BMI     LC2F3
        LEAY    -1,Y
        BNE     LC2E1
        LDA     DPPIADB	; <$22	; PIA1DB
		BMI     LC2F2
        DECB
        BNE     LC2E1
        BRA     LC31B

LC2F2   SYNC
LC2F3   LDA     DPDataReg	; <$43 	; DATAREG 
        LDB     DPPIADB	; <$22	; PIA1DB 
		STA     ,X+
        BRA     LC2F2

LC2FB   LDX     #$004F
        LDA     #$3F
        STA     $0609
        LDB     #$05
        LDA     #$88
        ORA     $0606
        STA     DPCmdReg	; <$40	; CMDREG 
LC30C   
		LDA     DPPIACRB	; <$23	; PIA1CRB 
        BMI     LC327
        LEAY    -1,Y
        BNE     LC30C
        LDA     DPPIADB	; <$22	; PIA1DB
		BMI     LC327
        DECB
        BNE     LC30C
LC31B   LDA     #$D0
        STA     DPCmdReg	; <$40	; CMDREG 
        CLRA
        TFR     A,DP
        LDA     #$FE
        ORCC    #$01
        RTS

LC327   LDA     DPDataReg	; <$43	; DATAREG 
        TST     DPPIADB	; <$22	; PIA1DB 
		STA     ,X+
        SYNC
        LDA     DPDataReg	; <$43	; DATAREG 
        TST     DPPIADB	; <$22	; PIA1DB 
		STA     ,X
LC334   SYNC
        LDA     DPDataReg	; <$43	; DATAREG 
        TST     DPPIADB	; <$22	; PIA1DB 
		BRA     LC334

LC33B   LDA     #$5F
LC33D   CMPX    #$86DF
Lc33E	EQU		LC33D+1

		STA     $0609
        BSR     LC382
        LDA     #$A8
        ORA     $0606
        STA     DPCmdReg	; <$40	; CMDREG
        LDA     ,X+
LC34E   
		LDB     DPPIACRB	; <$23	; PIA1CRB
        BMI     LC35B
        LEAY    -1,Y
        BNE     LC34E
        BRA     LC31B

LC358   LDA     ,X+
        SYNC
LC35B   STA     DPDataReg	; <$43	DATAREG 
        LDA     DPPIADB	; <$22	PIA1DB 
		BRA     LC358

LC361   LDA     #$47
        STA     $0609
        BSR     LC382
        LDA     #$F4
        ORA     $0606
        STA     DPCmdReg	; <$40	; CMDREG 
LC36F   LDD     ,X++
LC371   SYNC
        STB     DPDataReg	; <$43	; DATAREG  
        CMPA    DPPIADB	; <$22	; PIA1DB  
		DECA
        BNE     LC371
        LDA     ,X+
        SYNC
        STA     DPDataReg	; <$43	; DATAREG 
        CMPA    DPPIADB	; <$22	; PIA1DB 
		BRA     LC36F

LC382   LDA     DPTrkReg	; <$41	; TRKREG
        CMPA    #$10		; Write precom after track 16
        BLS     LC38F
        LDA     $0607
        ORA     #WPCEn		; $10
        BRA     LC394

LC38F   LDA     $0607
        ANDA    #~WPCEn
LC394 
		IFNE	DragonAlpha
		LBRA	AlphaDskCtl
		ELSE
		STA     DPDskCtl	; <$48
        RTS
		ENDC
		
CmdDskInit   BEQ     LC3BC
        JSR     >LC68F
        STB     <$EB
        JSR     >LC516
        BEQ     LC3C1
        DECB
        CMPB    #$01
        BHI     LC3B9
        STB     <$F4
        JSR     >LC516
        BEQ     LC3C3
        CMPB    #$28
        BEQ     LC3C5
        NEG     <$F4
        CMPB    #$50
        BEQ     LC3C5
LC3B9   JMP     >LC69C

LC3BC   LDB     $060A
        STB     <$EB
LC3C1   CLR     <$F4
LC3C3   LDB     #$28
LC3C5   STB     <$F2
        JSR     >LD6FB
        LBNE    LC456
        LDX     #$0800
        STX     <$EE
        JSR     >LC165
        LBNE    LC456
        LDA     #$01
        STA     <$ED
        JSR     >LC15F
        CMPB    #$80
        BEQ     LC456
LC3E5   CLR     <$F3
        CLR     <$ED
        JSR     >LC4E5
        JSR     >LC0FB
        BCS     LC456
        TST     <$F4
        BEQ     LC404
        LDA     #$01
        STA     <$F3
        NEGA
        STA     <$ED
        JSR     >LC4E5
        JSR     >LC0FB
        BCS     LC456
LC404   INC     <$EC
        LDA     <$EC
        CMPA    <$F2
        BCS     LC3E5
        JSR     >LC165
        BCS     LC456
LC411   JSR     >LC162
        BCS     LC456
        CLRA
        JSR     >LC4CE
        INC     <$EC
        LDA     <$EC
        CMPA    <$F2
        BCS     LC411
        LDX     <$EE
        LDD     <$8A
LC426   STD     ,X++
        CMPX    #$0B00
        BNE     LC426
        LDA     #$01
        STA     <$ED
        LDA     #$14
        BSR     LC43F
        DEC     <$ED
        DEC     <$EE
        LDA     #$10
        BSR     LC445
        BRA     LC459

LC43F   PSHS    A
        BSR     LC480
        PULS    A
LC445   STA     <$EC
        JSR     >LC101
        BCS     LC456
        INC     <$ED
        INC     <$EE
        JSR     >LC101
        BCS     LC456
        RTS

LC456   JMP     >LC69E

LC459   INC     <$EE
        LDX     <$EE
        LDD     #$890A
LC460   STA     ,X
        LEAX    $19,X
        DECB
        BNE     LC460
        BSR     LC46E
        LDA     #$14
        STA     <$EC
LC46E   LDD     #$1003
        STB     <$ED
LC473   JSR     >LC101
        BCS     LC456
        INC     <$ED
        DECA
        BNE     LC473
        JMP     >LC0B8

LC480   STA     <$EC
        LDA     #$12
        LDB     #$5A
        TST     <$F4
        BEQ     LC48C
        ASLB
        ASLA
LC48C   STA     $08FD
        COMA
        STA     $08FF
        LDA     <$F2
        STA     $08FC
        COMA
        STA     $08FE
        LDX     <$EE
        LDU     #$0900
        LDA     #$FF
LC4A3   STA     ,X+
        DECB
        BNE     LC4A3
        LDD     #$242D
        TST     <$F4
        BEQ     LC4BC
        BPL     LC4B9
        LDD     #$B4FF
LC4B4   STB     ,U+
        DECA
        BNE     LC4B4
LC4B9   LDD     #$485A
LC4BC   LDU     <$8A
        PSHS    A
        BSR     LC4C4
        PULS    B
LC4C4   LDX     <$EE
        ABX
        LDA     #$FC
        STU     ,X++
        STA     ,X
        RTS

LC4CE   CLR     <$ED
        TST     <$F4
        BEQ     LC4D6
        BSR     LC4D6
LC4D6   LDA     #$12
LC4D8   INC     <$ED
        JSR     >LC15F
        LBCS    LC456
        DECA
        BNE     LC4D8
LC4E4   RTS

LC4E5   LDU     <$EE
        LDX     #DDDF7
        LDY     #DDDE4
        LDB     #$0C
        BSR     LC513
LC4F2   LDX     #DDE03
        LDB     #$06
        BSR     LC513
        LDA     #$01
        LDB     <$EC
        STD     ,U++
        LDB     <$F3
        STB     ,U+
        LDB     ,Y+
        STD     ,U++
        STA     ,U+
        LDB     #$12
        BSR     LC513
        TST     ,Y
        BNE     LC4F2
        LDB     #$03
LC513   JMP     >$B7CC

LC516   JSR     <$A5
        BEQ     LC4E4
        JSR     >$89AA
        JMP     >LC63F

CmdBackup   
		LEAS    -16,S
        TFR     S,U
        TFR     U,D
        SUBD    #$0040
        SUBD    <$1F
        LBMI    $8342
        CMPA    #$01
        LBLT    $8342
        STA     15,U
        LDA     #$12
        STA     14,U
        LDD     <$1F
        STD     5,U
        STD     12,U
        LDD     #$DF54
        STD     3,U
        LDD     #$DF63
        STD     10,U
        LDD     #$0001
        STD     1,U
        STD     8,U
        LDA     $060A
        STA     ,U
        STA     7,U
        LDY     #$02D0
        JSR     <$A5
        BEQ     LC5AB
        JSR     >LC63F
        CMPB    #$04
        LBHI    LC699
        STB     ,U
        STB     7,U
        JSR     <$A5
        BEQ     LC5AB
        CMPA    #$BC
        BNE     LC58F
        JSR     <$9F
        JSR     >LC63F
        CMPB    #$04
        LBHI    LC699
        STB     7,U
        BSR     LC516
        BEQ     LC5AB
        CMPB    #$02
        BEQ     LC592
        CMPB    #$01
        BEQ     LC598
LC58F   JMP     >BasicSNErr

LC592   TFR     Y,D
        LEAY    D,Y
        ASL     14,U
LC598   JSR     >LC516
        BEQ     LC5AB
        CMPB    #$50
        BEQ     LC5A7
        CMPB    #$28
        BEQ     LC5AB
        BRA     LC58F

LC5A7   TFR     Y,D
        LEAY    D,Y
LC5AB   CLRA
LC5AC   LEAY    1,Y
        LEAX    ,U
        BSR     LC61F
LC5B2   LEAY    -1,Y
        BNE     LC5BC
        BSR     LC5D5
        LEAS    $10,U
LC5BB   RTS

LC5BC   CMPA    15,U
        BNE     LC5CE
        BSR     LC5D5
        PSHS    D
        LDD     <$1F
        STD     12,U
        STD     5,U
        PULS    D
        BRA     LC5AC

LC5CE   LDB     #$02
        BSR     LC5E4
        INCA
        BRA     LC5B2

LC5D5   TSTA
        BEQ     LC5BB
        LEAX    7,U
        BSR     LC61F
        LDB     #$03
LC5DE   BSR     LC5E4
        DECA
        BNE     LC5DE
LC5E3   RTS

LC5E4   PSHS    D
        LDA     ,X
        STA     <$EB
        LDD     5,X
        STD     <$EE
        LDD     1,X
        STD     <$EC
        LDB     1,S
        JSR     >LC106
        BCC     LC60D
        STB     $0603
        LDA     1,S
        CMPA    #$02
DC601   EQU     *+1
DC600   BNE     LC607
DC603   EQU     *+1
DC602   PULS    D,X
DC604   JSR     >LC5D5
LC607   LDB     $0603
        JMP     >LC69E

LC60D   INC     2,X
        LDA     2,X
        CMPA    14,U
        BLS     LC61B
        LDA     #$01
        STA     2,X
        INC     1,X
LC61B   INC     5,X
        PULS    D,PC

LC61F   LDB     ,U
        CMPB    7,U
        BNE     LC5E3
        PSHS    A,X,Y,U
        JSR     >$BA77
        LDX     1,S
        LDX     3,X
        JSR     >BasicPrintStr
        LDX     #DDF77
        JSR     >BasicPrintStr
        JSR     >$B505
        JSR     >$BA77
        PULS    A,X,Y,U,PC

LC63F   PSHS    Y,U
        JSR     >$8E51
        TSTB
        BNE     LC64A
        JMP     >$8B8D

LC64A   PULS    Y,U,PC

LC64C   CMPA    #$FF
        LBEQ    BasicSNErr
        SUBA    #$CE
        BPL     LC659
LC656   JMP     >BasicSNErr

LC659   CMPA    #$1A
        BCC     LC663
        LDX     #CommandDispatchTable
        JMP     >$84ED

LC663   JMP     [>$0137]

LC667   SUBB    #$44
        BPL     LC66D
        BRA     LC656

LC66D   CMPB    #$0E
        BCC     LC679
        LDX     #FunctionDipatchTable
        JSR     [B,X]
        JMP     >$8874

LC679   JMP     [>$013C]

LC67D   LDX     #$0634
LC680   JSR     >LD2B4
        BNE     LC69E
        CLR     2,X
        LEAX    7,X
        CMPX    #$0650
        BCS     LC680
LC68E   RTS

LC68F   JSR     >$8E51
        TSTB
        BEQ     LC699
        CMPB    #$04
        BLS     LC68E
LC699   LDB     #$28
LC69C   EQU     *+1
        CMPX    #DC6A4
LC69E   STB     $0619
        LDX     <$68
DC6A4   EQU     *+1
        STX     $0617
        JSR     >$8434
        CLR     <$F6
        JSR     >$BDDC
        JSR     >$BAC3
        CLR     <$6F
        JSR     >$90A1
        TST     $0614
        BPL     LC6C1
        LDX     <$68
        LEAX    1,X
        BNE     LC6D2
LC6C1   JSR     >$90F8
        LDX     #$82A9
        LDB     $0619
        BPL     LC6CF
        LDX     #DDF13
LC6CF   JMP     >$835E

LC6D2   LDX     #$84DA
        PSHS    X
        LDD     $0615
        STD     <$2B
        JMP     >$85E7

LC6DF   NOP
        CLRA
        TFR     A,DP
        JSR     >LC0B8
        CLR     $0609
        CLR     $0605
        CLR     $0613
        LDA     #$35
        STA     PIA0CRB 
        JMP     >$B44F

LC6F7   LDA     DPCmdReg	; <$40	; CMDREG
        CLRB
        TFR     B,DP
DC6FC   LEAS    12,S
        TSTA
LC6FF   RTS

LC700   TST     <$F6
        BNE     LC71E
        LDA     $0605
        BEQ     LC71E
        DECA
        STA     $0605
        BNE     LC71E
        BSR     DDosSyncDir
        BNE     LC721
        LDA     $0607
        ANDA    #~MotorOn	; $FB
        
	IFNE	DragonAlpha
	LBSR	AlphaDskCtl
	ELSE
	STA     DSKCTL
	ENDC
		
		STA     $0607
LC71E   JMP     >$9D3D

LC721   JMP     >LC69E

LC724   TFR     S,D
        SUBD    #$0100
        SUBD    <$1F
        BMI     LC731
        CLRB
        TSTA
        BNE     LC6FF
LC731   JMP     >$8342

;
; Copy updated track 20 to track 16
;

DDosSyncDir   
		JSR     >LC67D
        LEAS    -8,S
        LEAU    ,S
        LEAY    4,U
        LDX     #$0800
        STX     <$EE
        CLR     2,U
        LDB     <$EB
        STB     1,U
        LDB     #$01
        STB     ,U
        CLR     <$EB
        LDX     #$06AA
LC751   LDB     #$12
        STB     3,U
        INC     <$EB
LC757   LDB     3,U
        LDA     B,X
        BITA    ,U
        BEQ     LC77D
        COMA
        ANDA    B,X
        STA     B,X
        INC     2,U
        STB     <$ED
        STB     ,Y+
        LDB     #$14
        STB     <$EC
        JSR     >DoReadAbsSector
        BNE     LC6FF
        INC     <$EE
        LDB     2,U
        CMPB    #$04
        BCS     LC77D
        BSR     LC797
LC77D   DEC     3,U
        BNE     LC757
        TST     2,U
        BEQ     LC787
        BSR     LC797
LC787   ASL     ,U
        LDA     ,U
        CMPA    #$08
        BLS     LC751
        LDA     1,U
        STA     <$EB
        LEAS    8,U
        CLRB
        RTS

LC797   LDA     #$10
        STA     <$EC
LC79B   DEC     <$EE
        LEAY    -1,Y
        LDA     ,Y
        STA     <$ED
        JSR     >LC101
        BEQ     LC7AB
        LEAS    2,S
        RTS

LC7AB   DEC     2,U
        BNE     LC79B
LC7AF   RTS

LC7B0   
		TST     PIA1CRA
       TST     PIA1CRB
        RTI
LC7B7   BSR     DDosValidFilename
        BNE     LC7AF
        JMP     >DDosOpenFile

;
; Validate filename and copy to current drive block
;

DDosValidFilename   
	LDA     $060A
        STA     $065B
        CLR     $0660
        LDU     #$0650
        LDA     #$07
LC7CC   CLR     A,U
        DECA
        BPL     LC7CC
        LDA     2,Y
        STA     $065A
        LDA     1,Y
        STA     $0659
        LDA     ,Y
        STA     $0658
        CMPB    #$0E
        BHI     LC829
        CMPB    #$03
        BCS     LC811
        SUBB    #$02
        LDA     B,X
        CMPA    #$3A
        BNE     LC7F6
        INCB
        LDA     B,X
        INCB
        BRA     LC800

LC7F6   ADDB    #$02
        LDA     1,X
        CMPA    #$3A
        BNE     LC811
        LDA     ,X++
LC800   SUBA    #$30
        LBLS    LC699
        CMPA    #$04
        LBHI    LC699
        STA     $065B
        SUBB    #$02
LC811   LDA     ,X+
        DECB
        BMI     LC87A
        CMPA    #$2F
        BEQ     LC81E
        CMPA    #$2E
        BNE     LC83A
LC81E   CMPU    #$0650
        BEQ     LC829
        TST     $0660
        BEQ     LC82C
LC829   LDB     #$96
        RTS

LC82C   INC     $0660
        LDU     #$0658
        CLR     ,U
        CLR     1,U
        CLR     2,U
        BRA     LC811

LC83A   CMPA    #$41
        BCS     LC84E
        CMPA    #$5A
        BLS     LC85A
        SUBA    #$20
        CMPA    #$41
        BCS     LC829
        CMPA    #$5A
        BLS     LC85A
        BRA     LC829

LC84E   CMPA    #$2D
        BEQ     LC85A
        CMPA    #$30
        BCS     LC829
        CMPA    #$39
        BHI     LC829
LC85A   STA     ,U+
        CMPU    #$065B
        BNE     LC867
        TSTB
        BNE     LC829
        BRA     LC87A

LC867   CMPU    #$0658
        BNE     LC811
        LDA     ,X+
        DECB
        BMI     LC87A
        CMPA    #$2E
        BEQ     LC81E
        CMPA    #$2F
        BEQ     LC81E
LC87A   CLRB
        RTS

;
; Open a file.
;

DDosOpenFile   
		LDX     #$06BD
        CLR     <$F1
        LDD     $0650
LC884   CMPD    ,X
        BNE     LC89F
        LDU     #$0652
        LEAY    2,X
        LDB     #$0A
LC890   LDA     ,U+
        CMPA    ,Y+
        BNE     LC89C
        DECB
        BNE     LC890
        LBRA    LC947

LC89C   LDD     $0650
LC89F   LEAX    $1F,X
        INC     <$F1
        CMPX    #$07F3
        BCS     LC884
        CLR     <$F1
        LDX     #$06BD
LC8AE   TST     ,X
        BEQ     LC8BF
        LEAX    $1F,X
        INC     <$F1
        CMPX    #$07F3
        BCS     LC8AE
        LDB     #$A2
LC8BE   RTS

LC8BF   LDB     #$0C
        TFR     X,Y
        LDU     #$0650
LC8C6   LDA     ,U+
        STA     ,Y+
        DECB
        BNE     LC8C6
        STA     <$EB
        LDU     #$061C
        LDB     #$06
        MUL
        LEAU    D,U
        INC     5,U
        LDB     #$13
LC8DB   CLR     ,Y+
        DECB
        BNE     LC8DB
        LDA     #$80
        STA     15,X
        CLR     $0681
        JSR     >LD17D
        BNE     LC8BE
        LDY     ,X
        LEAY    2,Y
        LDA     #$10
        STA     $0660
LC8F6   STY     $065C
        JSR     >DDosFindAndRead
        BNE     LC8BE
        LDX     5,X
        LEAU    $00FA,X
        STU     $065E
LC908   LDA     ,X
        BITA    #$81
        BNE     LC928
        LDD     $0650
        CMPD    1,X
        BNE     LC928
        LDU     #$0652
        LEAY    3,X
        LDB     #$09
LC91D   LDA     ,U+
        CMPA    ,Y+
        BNE     LC928
        DECB
        BNE     LC91D
        BRA     LC954

LC928   LDA     ,X
        BITA    #$08
        BNE     LC944
        INC     $0681
        LEAX    $19,X
        CMPX    $065E
        BCS     LC908
        LDY     $065C
        LEAY    1,Y
        DEC     $0660
        BNE     LC8F6
LC944   JSR     >LCEAC
LC947   CLRB
        TST     15,X
        BPL     LC94E
        LDB     #$A0
LC94E   LEAX    12,X
        LDA     <$F1
        TSTB
        RTS

LC954   PSHS    X
        JSR     >LCEAC
        PULS    Y
        LDA     $0681
        STA     $1D,X
        LDA     ,Y
        STA     15,X
        LDD     12,Y
        STD     $15,X
        LDA     14,Y
        STA     $17,X
        STA     $19,X
        CLR     $18,X
        CLR     $13,X
        CLR     $14,X
        LDD     15,Y
        STD     $1A,X
        LDA     $11,Y
        STA     $1C,X
        LDD     #$FFFF
        STD     $10,X
        STA     $12,X
        BRA     LC947

;
; Read from a file.
;

DDosFRead   
		CLR     <$F5
        STA     <$F1
        BRA     LC99E

LC997   LDA     #$01

        FCB     $8C

LC99A   LDA     #$FF
        STA     <$F5
LC99E   STY     $0661
        LBEQ    LCA89
        STU     $0669
        STB     $0663
        PSHS    X
        JSR     >LCEAC
        LDA     11,X
        STA     <$EB
        TST     <$F5
        BNE     LC9C4
        LDD     $0661
        ADDD    13,X
        BCC     LC9C2
        INC     12,X
LC9C2   STD     13,X
LC9C4   PULS    X
        LDB     $0663
LC9C9   CLRA
        NEGB
        BNE     LC9CE
        INCA
LC9CE   CMPD    $0661
        BLS     LC9D7
        LDD     $0661
LC9D7   PSHS    D,X
        LDU     $0669
        JSR     >LCA8B
        BNE     LC9EF
        TFR     D,Y
        LDA     15,X
        BITA    #$02
        BEQ     LC9F2
        TST     <$F5
        BEQ     LC9F2
        LDB     #$98
LC9EF   LEAS    4,S
        RTS

LC9F2   LDX     2,S
        TST     1,S
        BNE     LCA22
        TST     <$F5
        BEQ     LCA03
        BPL     LCA08
        JSR     >LD303
        BRA     LCA0B

LCA03   JSR     >DDosReadAbsSector
        BRA     LCA0B

LCA08   JSR     >DDosWriteAbsSector
LCA0B   BNE     LC9EF
        INC     2,S
        LDX     $0669
        LEAX    1,X
        STX     $0669
        DEC     $0661
        LDD     $0661
        PULS    D,X
        BNE     LC9C9
        RTS

LCA22   TST     <$F5
        BMI     LCA6C
        JSR     >DDosFindAndRead
        BNE     LC9EF
        STX     $0667
        LDY     2,S
        LDB     $0663
        TST     <$F5
        BEQ     LCA60
        LDA     #$FF
        STA     2,X
        LDX     5,X
        ABX
        TFR     X,D
        DECB
        BCC     LCA44
LCA44   LDB     1,S
LCA46   LDA     ,Y+
        STA     ,X+
        DECB
        BNE     LCA46
        TFR     X,D
        TSTB
        BNE     LCA6C
        LDX     $0667
        PSHS    Y
        JSR     >LD2B4
        PULS    Y
        BNE     LC9EF
        BRA     LCA6C

LCA60   LDX     5,X
        ABX
        LDB     1,S
LCA65   LDA     ,X+
        STA     ,Y+
        DECB
        BNE     LCA65
LCA6C   LDX     $0669
        LEAX    1,X
        STX     $0669
        TFR     Y,X
        LDD     $0661
        SUBD    ,S++
        STD     $0661
        LEAS    2,S
        BEQ     LCA89
        CLR     $0663
        CLRB
        JMP     >LC9C9

LCA89   CLRB
        RTS

LCA8B   JSR     >LCEAC
LCA8E   TFR     U,D
        SUBD    $13,X
        BCS     LCAA2
        TSTA
        BNE     LCAA2
        CMPB    $17,X
        BCC     LCAA2
        ADDD    $15,X
        BRA     LCAB4

LCAA2   TFR     U,D
        SUBD    $18,X
        BCS     LCAB7
        TSTA
        BNE     LCAB7
        CMPB    $1C,X
        BCC     LCAB7
        ADDD    $1A,X
LCAB4   ORCC    #$04
        RTS

LCAB7   PSHS    U
        BSR     LCAF9
        BNE     LCAC8
        LDD     $066B
        CMPD    $066D
        BHI     LCACA
        LDB     #$9A
LCAC8   PULS    U,PC

LCACA   SUBB    2,Y
        SBCA    #$00
        STD     $13,X
        LDA     2,Y
        STA     $17,X
        LDD     ,Y
        STD     $15,X
        TFR     Y,D
        PSHS    U
        SUBD    ,S++
        PULS    U
        CMPB    #$13
        BCC     LCAF7
        LDA     5,Y
        STA     $1C,X
        LDD     3,Y
        STD     $1A,X
        LDD     $066B
        STD     $18,X
LCAF7   BRA     LCA8E

LCAF9   PSHS    X
        CLR     $066C
        CLR     $066B
        STU     $066D
        LDB     $1D,X
        STB     $0682
        JSR     >DDosGetDirEntry
        BNE     LCB56
        TFR     X,U
        PULS    X
        LEAY    12,U
        LDB     #$04
LCB17   LDA     ,U
        ANDA    #$20
        BEQ     LCB20
        LDA     $18,U
LCB20   PSHS    D
LCB22   LDD     $066B
        ADDB    2,Y
        ADCA    #$00
        STD     $066B
        CMPD    $066D
        BHI     LCB55
        LEAY    3,Y
        DEC     1,S
        BNE     LCB22
        LDB     ,S
        BEQ     LCB53
        LEAS    2,S
        STB     $0682
        PSHS    X
        JSR     >DDosGetDirEntry
        TFR     X,U
        PULS    X
        BEQ     LCB4D
        RTS

LCB4D   LEAY    1,U
        LDB     #$07
        BRA     LCB17

LCB53   LEAY    -3,Y
LCB55   CLRB
LCB56   LEAS    2,S
        RTS

;
; Write to a file.
;

DDosFWrite   
		STA     <$F1
        STX     $0671
        STU     $0673
        STY     $0675
        STB     $0677
        JSR     >LCEAC
        LDB     11,X
        STB     <$EB
LCB6F   JSR     >DDosGetFlen
        BEQ     LCB82
        CMPB    #$9C
        BEQ     LCB79
LCB78   RTS

LCB79   LDA     <$F1
        JSR     >DDosCreateFile
        BNE     LCB78
        BRA     LCB6F

LCB82   CMPU    $0675
        BHI     LCB92
        BCS     LCB8F
        CMPA    $0677
        BCC     LCB92
LCB8F   LDB     #$9A
LCB91   RTS

LCB92   PSHS    A
        LDD     $0673
        ADDB    $0677
        ADCA    $0676
        PSHS    B
        TFR     A,B
        LDA     $0675
        ADCA    #$00
        PSHS    U
        SUBD    ,S++
        TFR     B,A
        PULS    B
        BHI     LCBB8
        BCS     LCBC0
        SUBB    ,S
        BCC     LCBBC
        BRA     LCBC0

LCBB8   SUBB    ,S
        SBCA    #$00
LCBBC   BSR     LCBEC
        BNE     LCBE9
LCBC0   LEAS    1,S
        LDB     $0677
        LDX     $0671
        LDY     $0673
        LDU     $0675
        JSR     >LC997
        BNE     LCB91
        TST     $0608
        BEQ     LCB91
        LDB     $0677
        LDX     $0671
        LDY     $0673
        LDU     $0675
        LBRA    LC99A

LCBE9   LEAS    1,S
        RTS

LCBEC   LEAS    -12,S
        STD     ,S
        STD     10,S
        LDA     #$01
        STA     <$F6
        JSR     >LD17D
        LBNE    LCCE2
        STX     8,S
        JSR     >LCEAC
        LDB     $1E,X
        JSR     >DDosGetDirEntry
        LBNE    LCCE2
        STX     4,S
        LDU     $067F
        LDA     #$FF
        STA     2,U
        CLRA
        LDB     $18,X
        BNE     LCC1C
        INCA
LCC1C   ADDD    ,S
        TSTB
        BNE     LCC22
        DECA
LCC22   STD     ,S
        TSTA
        LBEQ    LCCCA
        LDB     #$04
        LEAY    12,X
        LDA     ,X
        BITA    #$01
        BEQ     LCC37
        LEAY    1,X
        LDB     #$07
LCC37   TST     2,Y
        BNE     LCC4F
        LDD     #$FFFF
        STD     6,S
        LEAY    -3,Y
        STY     2,S
        LDX     8,S
        TST     2,X
        LBNE    LCCE8
        BRA     LCC8D

LCC4F   TST     2,Y
        BEQ     LCC58
        LEAY    3,Y
        DECB
        BNE     LCC4F
LCC58   LEAY    -3,Y
        LDD     ,Y
        ADDB    2,Y
        ADCA    #$00
        STD     6,S
        STY     2,S
        LDX     8,S
        TST     2,X
        BEQ     LCC8D
        LDD     6,S
        SUBD    3,X
        BEQ     LCC9D
        JSR     >LCD31
        BEQ     LCC7C
        CMPB    #$94
        BNE     LCCE2
        BRA     LCCE8

LCC7C   LDX     8,S
        PSHS    A,U
        LDB     2,X
        LDX     3,X
        JSR     >LD012
        PULS    A,U
        BNE     LCCE2
        BRA     LCC92

LCC8D   JSR     >LCD31
        BNE     LCCE2
LCC92   LDX     8,S
        STU     3,X
        STA     2,X
        CMPU    6,S
        BNE     LCCE8
LCC9D   LDA     ,S
        CMPA    2,X
        BCS     LCCA5
        LDA     2,X
LCCA5   LDY     2,S
        PSHS    A
        ADDA    2,Y
        BCC     LCCB2
        PULS    A
        BRA     LCCE8

LCCB2   STA     2,Y
        LDA     2,X
        SUBA    ,S
        STA     2,X
        LDD     3,X
        ADDB    ,S
        ADCA    #$00
        STD     3,X
        LDA     1,S
        SUBA    ,S+
        STA     ,S
        BNE     LCC8D
LCCCA   LDX     4,S
        TFR     X,U
        JSR     >LCEAC
        LDD     10,S
        ADDD    $11,X
        BCC     LCCDB
        INC     $10,X
LCCDB   STD     $11,X
        STB     $18,U
        CLRB
LCCE2   LEAS    12,S
        CLR     <$F6
        TSTB
        RTS

LCCE8   LDD     2,S
        TFR     D,Y
        SUBD    4,S
        CMPB    #$13
        BCC     LCCFD
        LEAY    3,Y
        STY     2,S
LCCF7   LDD     3,X
        STD     ,Y
        BRA     LCC9D

LCCFD   LDA     #$01
        JSR     >LD0FC
        BNE     LCCE2
        LDY     4,S
        STA     $18,Y
        LDB     ,Y
        ORB     #$20
        STB     ,Y
        LDB     #$FF
        STB     2,X
        LDB     #$01
        STB     ,U
        STU     4,S
        JSR     >LCEAC
        STA     $1E,X
        LEAY    $19,U
        LDB     #$18
LCD25   CLR     ,-Y
        DECB
        BNE     LCD25
        STY     2,S
        LDX     8,S
        BRA     LCCF7

LCD31   STS     $0601
        LEAS    -9,S
        CLR     4,S
        JSR     >LD17D
        LBNE    LCE34
        LDY     ,X
        LDU     $11,S
        STU     5,S
        LEAX    1,U
        BEQ     LCD5B
        BSR     LCD8C
        BNE     LCD89
        CMPU    #$05A0
        BCS     LCD5B
        LDU     #$058E
        BRA     LCD7C

LCD5B   LEAU    ,Y
LCD5D   LDA     #$FF
        STA     ,S
LCD61   LEAU    -$12,U
        STU     -2,S
        BMI     LCD74
        BSR     LCD8C
        BEQ     LCD5D
        TST     ,S
        BPL     LCD89
        STU     ,S
        BRA     LCD61

LCD74   LDU     ,S
        STU     -2,S
        BPL     LCD89
        LEAU    ,Y
LCD7C   LEAU    $12,U
        CMPU    #$0B40
        BHI     LCD8F
        BSR     LCD8C
        BEQ     LCD7C
LCD89   LBRA    LCE0E

LCD8C   LBRA    LCE3A

LCD8F   LDA     #$FF
        STA     7,S
        LDA     4,S
LCD95   LDU     <$8A
        LSRA
        BCS     LCD9D
        LDU     #$05A0
LCD9D   BSR     LCD8C
        LDB     #$B4
LCDA1   LDA     ,X+
        BNE     LCDAC
        LEAU    8,U
        DECB
        BNE     LCDA1
        BRA     LCDED

LCDAC   CLRB
        STB     8,S
        PSHS    U
LCDB1   INCB
        LDA     ,X+
        INCA
        BEQ     LCDB1
        CMPB    10,S
        BLS     LCDBF
        STB     10,S
        STU     ,S
LCDBF   LEAX    -1,X
        LDA     #$08
        MUL
        LEAU    D,U
LCDC6   CLRB
        LDA     ,X+
        BNE     LCDB1
        LEAU    8,U
        TFR     X,D
        CMPB    #$B4
        BCS     LCDC6
        PULS    U
        BSR     LCE3A
        LEAU    8,U
        LDA     ,X
        LDB     8,S
        CMPB    #$01
        BHI     LCDE6
LCDE1   LEAU    -1,U
        ASLA
        BCC     LCDE1
LCDE6   ASLA
        BCC     LCDED
        LEAU    -1,U
        BRA     LCDE6

LCDED   CMPB    #$02
        BCC     LCE0E
        CMPB    7,S
        BHI     LCE0E
        LDA     7,S
        INCA
        BNE     LCE04
        STB     7,S
        STU     5,S
        LDA     4,S
        EORA    #$03
        BRA     LCD95

LCE04   LDU     5,S
        BSR     LCE3A
        BNE     LCE0E
        LDB     #$94
        BRA     LCE34

LCE0E   BSR     LCE3A
        CLRB
LCE11   INCB
        BEQ     LCE2B
        PSHS    A
        COMA
        ANDA    ,X
        STA     ,X
        PULS    A
        ASLA
        BCC     LCE24
        LDA     #$01
        LEAX    1,X
LCE24   BITA    ,X
        BNE     LCE11
        TFR     B,A
LCE2B   EQU     *+1
        CMPX    #$86FF
        LDX     2,S
        LDB     #$FF
        STB     2,X
        CLRB
LCE34   LDS     $0601
        TSTB
        RTS

LCE3A   PSHS    Y,U
        LDA     #$01
        CMPU    #$05A0
        BCS     LCE4B
        LEAY    1,Y
        LEAU    $FA60,U
        ASLA
LCE4B   PSHS    U
        BITA    12,S
        BNE     LCE5E
        STA     12,S
        JSR     >DDosFindAndRead
        BNE     LCE34
        STX     10,S
        LDA     #$FF
        STA     2,X
LCE5E   LDX     10,S
        LDX     5,X
        PULS    D
        LSRA
        RORB
        LSRA
        RORB
        LSRA
        RORB
        LDA     3,S
        ANDA    #$07
        LDU     #$A672
        NEGA
        LDA     A,U
        ABX
        BITA    ,X
        PULS    Y,U,PC

;
; Get a file length.
;

DDosGetFlen   
		STA     <$F1
        BSR     LCEAC
        TST     15,X
        BPL     LCE84
        LDB     #$9C
LCE83   RTS

LCE84   LDA     $12,X
        LDU     $10,X
        LEAY    1,U
        BNE     LCEAA
        JSR     >LCAF9
        BNE     LCE83
        LDB     $0682
        STB     $1E,X
LCE99   LDA     $18,U
        STA     $12,X
        LDU     $066B
        TSTA
        BEQ     LCEA7
        LEAU    -1,U
LCEA7   STU     $10,X
LCEAA   CLRB
LCEAB   RTS

LCEAC   PSHS    D
        LDA     <$F1
        LDB     #$1F
        MUL
        TFR     D,X
        LEAX    $06BD,X
        PULS    D,PC

;
; Close All open files.
;

DDosCloseAll   
		LDA     #$0A
        STA     <$F1
LCEBF   BSR     LCEAC
        LDA     11,X
        CMPA    <$EB
        BNE     LCECB
        BSR     LCED3
        BNE     LCEAB
LCECB   DEC     <$F1
        BPL     LCEBF
LCECF   CLRB
        RTS

;
; Close a single file.
;

DDosCloseFile   
		STA     <$F1
LCED3   BSR     LCEAC
        TST     ,X
        BEQ     LCECF
        LDA     <$EB
        PSHS    A
        LDA     11,X
        STA     <$EB
        CLR     ,X
        JSR     >LD17D
        BNE     LCF0E
        TST     5,X
        BEQ     LCEF3
        DEC     5,X
        BEQ     LCEF3
        CLRB
        BRA     LCF0E

LCEF3   LDB     2,X
        BEQ     LCF04
        PSHS    X
        LDX     3,X
        JSR     >LD012
        PULS    X
        BNE     LCF0E
        CLR     2,X
LCF04   JSR     >DDosSyncDir
        LDU     #$0696
        LDA     <$EB
        CLR     A,U
LCF0E   PULS    A
        STA     <$EB
        TSTB
LCF13   RTS

;
; Create a file.
;

DDosCreateFile   
		STA     $067D
        JSR     >LCEAC
        STX     $0678
        LDB     #$0C
        LDU     #$0650
LCF22   LDA     ,X+
        STA     ,U+
        DECB
        BNE     LCF22
        LDD     -4,U
        STD     $067A
        LDA     -2,U
        STA     $067C
        LDD     #$4241
        STD     -4,U
        LDA     #$4B
        STA     -2,U
        TST     15,X
        BMI     LCF69
        JSR     >DDosOpenFile
        CMPB    #$A0
        BEQ     LCF4F
        TSTB
        BNE     LCF13
        JSR     >DDosDeleteFile
        BNE     LCF13
LCF4F   TST     [$0678]
        BEQ     LCF69
        LDA     $067D
        JSR     >LD0CF
        BEQ     LCF61
        CMPB    #$9C
        BNE     LCF13
LCF61   LDA     $067D
        JSR     >DDosCloseFile
        BNE     LCF13
LCF69   LDD     $067A
        STD     $0658
        LDA     $067C
        STA     $065A
        JSR     >DDosOpenFile
        BEQ     LCF7E
        CMPB    #$A0
        BNE     LCF13
LCF7E   STA     <$F1
        JSR     >LCEAC
        TST     15,X
        BMI     LCF8A
        LDB     #$9E
LCF89   RTS

LCF8A   CLRA
        JSR     >LD0FC
        BNE     LCF89
        JSR     >LCEAC
        STA     $1D,X
        STA     $1E,X
        LDB     #$1C
LCF9B   CLR     B,X
        DECB
        CMPB    #$0C
        BCC     LCF9B
        LDB     #$18
LCFA4   CLR     B,U
        DECB
        BPL     LCFA4
        LEAU    1,U
        LDB     #$0B
LCFAD   LDA     ,X+
        STA     ,U+
        DECB
        BNE     LCFAD
        CLRB
LCFB5   RTS

;
; Delete a file from disk.
;

DDosDeleteFile   
		JSR     >LD0BC
        BNE     LCFB5
        PSHS    X
        LDB     $1D,X
        JSR     >LD208
        BNE     LD00C
        TFR     X,U
        PULS    X
        LEAY    12,U
        LDB     #$04
LCFCD   LDA     ,U
        ANDA    #$20
        BEQ     LCFD6
        LDA     $18,U
LCFD6   PSHS    D
        LDB     #$81
        STB     ,U
        PSHS    X
LCFDE   LDX     ,Y++
        LDB     ,Y+
        BEQ     LCFEE
        PSHS    Y
        BSR     LD012
        PULS    Y
        LBNE    LC9EF
LCFEE   DEC     3,S
        BNE     LCFDE
        PULS    X
        LDB     ,S
        BEQ     LD00B
        LEAS    2,S
        PSHS    X
        JSR     >LD208
        TFR     X,U
        PULS    X
        BNE     LCFB5
        LEAY    1,U
        LDB     #$07
        BRA     LCFCD

LD00B   CLRB
LD00C   CLR     <$F6
        LEAS    2,S
        TSTB
        RTS

LD012   CLRA
        PSHS    A
        PSHS    D,X
        JSR     >LD17D
        BNE     LD09A
        LDY     ,X
        LDD     2,S
        SUBD    #$05A0
        BCS     LD031
        LEAY    -1,Y
        STD     2,S
        ADDD    ,S
        SUBD    #$05A0
        BCC     LD098
LD031   LDD     2,S
        ADDD    ,S
        SUBD    #$05A0
        BCS     LD041
        STB     4,S
        NEGB
        ADDB    1,S
        STB     1,S
LD041   JSR     >DDosFindAndRead
        BNE     LD09A
        LDA     #$FF
        STA     2,X
        LDD     2,S
        LSRA
        RORB
        ROR     ,S
        LSRA
        RORB
        ROR     ,S
        LSRA
        RORB
        ROR     ,S
        LDX     5,X
        ABX
        LDB     #$01
        LDA     ,S
        BEQ     LD066
LD061   ASLB
        SUBA    #$20
        BNE     LD061
LD066   STB     ,S
        LDB     1,S
LD06A   LDA     ,S
        ORA     ,X
        STA     ,X
        DECB
        BEQ     LD08B
        ASL     ,S
        BCC     LD06A
        LDA     #$01
        STA     ,S
        LEAX    1,X
LD07D   CMPB    #$10
        BCS     LD06A
        LDA     #$FF
        STA     ,X+
        STA     ,X+
        SUBB    #$10
        BNE     LD07D
LD08B   LDX     #$05A0
        LEAS    4,S
        LDB     ,S+
        BNE     LD095
        RTS

LD095   LBRA    LD012

LD098   LDB     #$90
LD09A   LEAS    5,S
LD09C   RTS

LD09D   STA     <$F1
        JSR     >LCEAC
        LDA     15,X
        BMI     LD0CC
        TSTB
        BEQ     LD0AC
        ORA     #$02
LD0AC   EQU     *+1
        CMPX    #$84FD
        STA     15,X
        LDB     $1D,X
        JSR     >LD208
        BNE     LD09C
        STA     ,X
        CLRB
LD0BB   RTS

LD0BC   STA     <$F1
        JSR     >LCEAC
        LDA     15,X
        BMI     LD0CC
        BITA    #$02
        BEQ     LD0BB
        LDB     #$98
        RTS

LD0CC   LDB     #$9C
LD0CE   RTS

LD0CF   JSR     >LD0BC
        BNE     LD0CE
        LDB     #$0B
        LDU     #$0650
LD0D9   LDA     ,U+
        STA     ,X+
        DECB
        BNE     LD0D9
        LEAX    -11,X
        LDB     $1D,X
        JSR     >LD208
        BNE     LD0CE
        LDU     #$0650
        LDB     #$0B
        LEAX    1,X
LD0F1   LDA     ,U+
        STA     ,X+
        DECB
        BNE     LD0F1
        CLR     <$F6
        CLRB
LD0FB   RTS

LD0FC   NEGA
        STA     $067E
        JSR     >LD17D
        BNE     LD0FB
        LDX     ,X
        PSHS    X
        LEAX    2,X
LD10B   STX     $066F
        TFR     X,Y
        JSR     >DDosFindAndRead
        BNE     LD14A
        LDU     5,X
        LDB     #$0A
        TST     $067E
        BPL     LD123
        NEG     $067E
        BRA     LD12A

LD123   LDA     ,U
        BMI     LD142
        INC     $067E
LD12A   LEAU    $19,U
        DECB
        BNE     LD123
        LDX     $066F
        LEAX    1,X
        TFR     X,D
        SUBD    ,S
        CMPB    #$12
        BCS     LD10B
        LEAS    2,S
        LDB     #$92
        RTS

LD142   LDA     #$FF
        STA     2,X
        LDA     $067E
        CLRB
LD14A   LEAS    2,S
        RTS

;
; Get free space on a disk.
;

DDosGetFree   
		BSR     LD17D
        BNE     LD161
        LDY     ,X
        LDX     <$8A
        BSR     LD162
        BNE     LD161
        LEAY    1,Y
        BSR     LD162
        BNE     LD161
        CLRB
LD161   RTS

LD162   PSHS    X
        JSR     >DDosFindAndRead
        BNE     LD14A
        LDU     5,X
        PULS    X
        LDB     #$B4
LD16F   LDA     ,U+
LD171   LSRA
        BCC     LD176
        LEAX    1,X
LD176   TSTA
        BNE     LD171
        DECB
        BNE     LD16F
        RTS

LD17D   LDX     #$061C
        LDU     #$0696
        LDB     #$06
        LDA     <$EB
        LEAU    A,U
        DECA
        MUL
        LEAX    D,X
        TST     ,U
        BNE     LD1CF
        LDY     #$0168
        LDA     #$12
        STA     $10,U
        PSHS    X
        JSR     >DDosFindAndRead
        LBNE    LCB56
        LDX     5,X
        LDD     $00FE,X
        COMA
        COMB
        CMPD    $00FC,X
        PULS    X
        BNE     LD1D1
        STB     $10,U
        STA     12,U
        DEC     ,U
        CMPB    #$12
        BEQ     LD1C0
        CLRB
LD1C0   PSHS    B
        CLR     2,X
        LDD     #$0168
        TST     ,S+
        BNE     LD1CD
        ASLB
        ROLA
LD1CD   STD     ,X
LD1CF   CLRB
        RTS

LD1D1   LDB     #$90
LD1D3   RTS

;
; Get a directory entry
;

DDosGetDirEntry   
		LDA     #$FF
LD1D6   INCA
        SUBB    #$0A
        BGE     LD1D6
        ADDB    #$0A
        PSHS    D
        BSR     LD17D
        LBNE    LCB56
        LDD     ,X
        ADDD    #$0002
        ADDB    ,S+
        ADCA    #$00
        STD     $066F
        TFR     D,Y
        JSR     >DDosFindAndRead
        PULS    A
        BNE     LD1D3
        TFR     X,U
        LDB     #$19
        MUL
        STX     $067F
        LDX     5,X
        LEAX    D,X
        CLRB
        RTS

LD208   PSHS    D
        BSR     DDosGetDirEntry
        LBNE    LCB56
        LDY     $067F
        LDA     #$FE
        STA     2,Y
        CLRB
        PULS    D,PC

LD21B   LDX     #$0634
        LDU     <$8A
        LDB     #$04
LD222   LDA     2,X
        BEQ     LD23D
        CMPA    #$55
        BEQ     LD23F
        CMPY    ,X
        BNE     LD239
        LDA     <$EB
        CMPA    3,X
        BNE     LD239
        BSR     LD29D
        CLRB
        RTS

LD239   TST     2,X
        BNE     LD23F
LD23D   TFR     X,U
LD23F   LEAX    7,X
        DECB
        BNE     LD222
        LDB     #$FF
LD246   RTS

;
; Find a free buffer and read sector
;

DDosFindAndRead   
		PSHS    U
        JSR     >LD21B
        LBEQ    LCB56
        LEAX    ,U
        PULS    U
        BNE     LD25A
        BSR     LD274
        BNE     LD246
LD25A   CLR     2,X
        STY     ,X
        LDA     <$EB
        STA     3,X
        PSHS    X
        LDX     5,X
        JSR     >DDosReadAbsSector
        PULS    X
        BNE     LD246
        LDA     #$01
        STA     2,X
        CLRB
        RTS

LD274   PSHS    D,Y,U
LD276   LDX     #$0634
        LDB     #$04
LD27B   LDA     4,X
        CMPA    #$01
        BEQ     LD286
        LEAX    7,X
        DECB
        BNE     LD27B
LD286   BSR     LD29D
        LDA     2,X
        CMPA    #$55
        BEQ     LD276
        INCA
        BNE     LD295
        DEC     2,X
        BRA     LD276

LD295   BSR     LD2B4
        LBNE    LC9EF
        PULS    D,Y,U,PC

LD29D   LDB     #$04
        LDA     4,X
        LDU     #$0634
LD2A4   CMPA    4,U
        BHI     LD2AA
        DEC     4,U
LD2AA   LEAU    7,U
        DECB
        BNE     LD2A4
        LDA     #$04
        STA     4,X
        RTS

LD2B4   TST     2,X
        BMI     LD2BA
        CLRB
        RTS

LD2BA   LDA     <$EB
        PSHS    A
        PSHS    X
        LDA     #$FF
        STA     <$F6
        CLR     2,X
        LDA     3,X
        STA     <$EB
        LDY     ,X
        LDX     5,X
        JSR     >DDosWriteAbsSector
        PULS    X
        BNE     LD2F2
        LDA     <$EC
        CMPA    #$14
        BNE     LD2ED
        LDU     #$A673
        LDA     <$EB
        NEGA
        LDA     A,U
        LDU     #$06AA
        LDB     <$ED
        ORA     B,U
        STA     B,U
LD2ED   LDA     #$01
        STA     2,X
        CLRB
LD2F2   PULS    A
        STA     <$EB
        CLR     <$F6
        TSTB
        RTS

;
; Write absolute sector.
;

DDosWriteAbsSector   
	BSR     LD311
        JSR     >DoWriteAbsSector
LD2FF   LDX     <$EE
        TSTB
        RTS

LD303   BSR     LD311
        JSR     >LC15F
        BRA     LD2FF
;
; Read absolute sector
;

DDosReadAbsSector   
	BSR     LD311
        JSR     >DoReadAbsSector
        BRA     LD2FF

LD311   STX     <$EE
        LDX     #$06A6
        LDB     <$EB
        LDB     B,X
        CLRA
        PSHS    D
        CLR     ,-S
        TFR     Y,D
LD321   INC     ,S
        SUBD    1,S
        BPL     LD321
        ADDB    2,S
        LDA     ,S
        DECA
        INCB
        LEAS    3,S
        STD     <$EC
        RTS

CmdCopy   JSR     >DDosCloseAll
        BNE     LD36B
        LEAS    -7,S
        TFR     S,D
        SUBD    #$0100
        SUBD    <$1F
        LBMI    $8342
        CLRB
        TSTA
        LBEQ    $8342
        STD     2,S
        JSR     >LD6D4
        BNE     LD36B
        STA     ,S
        JSR     >DDosGetFlen
        BNE     LD36B
        JSR     <$A5
        CMPA    #$BC
        LBNE    BasicSNErr
        JSR     <$9F
        JSR     >LD6D4
        BEQ     LD36E
        CMPB    #$A0
        BEQ     LD36E
LD36B   JMP     >LC69E

LD36E   STA     1,S
        JSR     >DDosCreateFile
        BNE     LD36B
LD375   LDA     ,S
        STA     <$F1
        JSR     >LCEAC
        LDD     12,X
        CMPD    $10,X
        BCS     LD38B
        LDA     14,X
        CMPA    $12,X
        BEQ     LD3DB
LD38B   LDU     12,X
        LDA     14,X
        STA     6,S
        STU     4,S
        LDD     2,S
        ADDD    5,S
        STD     5,S
        BCC     LD39D
        INC     4,S
LD39D   LDA     4,S
        SUBA    $10,X
        BCS     LD3B2
        LDD     5,S
        SUBD    $11,X
        BLS     LD3B2
        LDD     $11,X
        SUBD    13,X
        STD     2,S
LD3B2   LDA     ,S
        LDU     12,X
        LDB     14,X
        LDY     2,S
        LDX     <$1F
        JSR     >DDosFRead
        BNE     LD36B
        LDA     1,S
        STA     <$F1
        JSR     >LCEAC
        LDY     $10,X
        LDB     $12,X
        LDU     2,S
        LDX     <$1F
        JSR     >DDosFWrite
        BNE     LD36B
        BRA     LD375

LD3DB   JSR     >DDosCloseAll
        LBNE    LD36B
        LEAS    7,S
        RTS

CmdMerge   JSR     >LD6CE
        BNE     LD433
        JSR     >LD46C
        BNE     LD433
        CMPA    #$01
        BNE     LD431
        LDU     <$1B
        LDY     <$19
        PSHS    Y,U
        LEAU    1,U
        STU     <$19
        JSR     >LD4E0
        PULS    X,U
        STU     <$1B
        STX     <$19
        LEAU    1,U
LD409   LDD     ,U++
        BEQ     LD42B
        LDD     ,U++
        STD     $02DA
        STD     <$2B
        CLRB
        LDX     #$02DC
LD418   INCB
        LDA     ,U+
        STA     ,X+
        BNE     LD418
        ADDB    #$04
        STB     <$03
        PSHS    U
        BSR     LD436
        PULS    U
        BRA     LD409

LD42B   CLR     $0611
        LBRA    LD4BD

LD431   LDB     #$2C
LD433   JMP     >LC69E

LD436   JSR     >$83FF
        BCS     LD44D
        LDD     <$47
        SUBD    ,X
        ADDD    <$1B
        STD     <$1B
        LDU     ,X
LD445   LDA     ,U+
        STA     ,X+
        CMPX    <$1B
        BNE     LD445
LD44D   LDD     <$1B
        STD     <$43
        ADDB    <$03
        ADCA    #$00
        STD     <$41
        JSR     >$831C
        LDU     #$02D8
LD45D   LDA     ,U+
        STA     ,X+
        CMPX    <$45
        BNE     LD45D
        LDX     <$41
        STX     <$1B
        JMP     >$83ED

LD46C   LDX     #$0650
        LDY     #$0009
        LDU     <$8A
        CLRB
        LDA     <$F1
        JSR     >DDosFRead
        BEQ     LD47E
        RTS

LD47E   LDA     #$55
        LDX     #$0650
        CMPA    ,X
        BNE     LD431
        COMA
        CMPA    8,X
        BNE     LD431
        LDA     1,X
        CLRB
        RTS

LD490   CLR     $0614
        CLR     $0619
        CLR     $0617
        CLR     $0618
        CMPA    #$22
        BEQ     LD4A2
        TSTA
        RTS

LD4A2   LEAS    2,S
        LDB     #$01
CmdLoad   EQU     *+1
        BRN     DD507
        STB     $0611
        JSR     >LD6CE
        BNE     LD433
        JSR     >LD46C
        LBNE    LD433
        CMPA    #$01
        BNE     LD504
        BSR     LD4E0
LD4BD   CLR     <$F6
        LDX     <$19
        JSR     >$85EE
        LDX     <$27
        STX     <$23
        LDX     <$1B
        STX     <$1D
        STX     <$1F
LD4CE   JSR     >$8514
        JSR     >$8434
        TST     $0611
        BEQ     LD4DC
        JMP     >$849F

LD4DC   CLRA
        JMP     >$8371

LD4E0   LDD     4,X
        TFR     D,Y
        ADDD    <$19
        STD     <$1F
        LDB     #$40
        JSR     >$8331
LD4ED   LDA     <$F1
        LDU     <$8A
        LDB     #$09
        LDX     <$19
        JSR     >DDosFRead
        LBNE    LC69E
        JSR     >$83ED
        LEAX    2,X
        STX     <$1B
LD503   RTS

LD504   CMPA    #$02
DD507   EQU     *+1
        LBNE    LD431
        LDU     6,X
        STU     <$9D
        JSR     <$A5
        BEQ     LD524
        PSHS    X
        BSR     LD581
        TFR     X,U
        PULS    X
        LDD     6,X
        SUBD    2,X
        STU     2,X
        ADDD    2,X
        STD     <$9D
LD524   LDY     4,X
        LDA     <$F1
        LDB     #$09
        LDU     <$8A
        LDX     2,X
        JSR     >DDosFRead
        LBNE    LC69E
        TST     $0611
        BEQ     LD503
        JMP     [>$009D]

CmdSave   JSR     >$8887
        JSR     >$8877
        JSR     <$A5
        BEQ     LD587
        LDY     #DDF8D
        BSR     LD572
        BSR     LD581
        STX     $0652
        BSR     LD581
        TFR     X,D
        CMPX    $0652
        LBCS    LC69C
        SUBD    $0652
        LBMI    $8B8D
        STD     $0654
        BSR     LD581
        STX     $0656
        LDB     #$02
        BRA     LD5A1

LD572   JSR     >LD6E2
        BEQ     LD57B
        CMPB    #$A0
        BNE     LD5BB
LD57B   JSR     >DDosCreateFile
        BNE     LD5BB
        RTS

LD581   JSR     >$89AA
        JMP     >$8E83

LD587   LDY     #DDF87
        BSR     LD572
        LDX     <$19
        STX     $0652
        LDD     <$1B
        SUBD    <$19
        STD     $0654
        LDX     #$8B8D
        STX     $0656
        LDB     #$01
LD5A1   LDX     #$0650
        LDA     #$55
        STA     ,X
        COMA
        STA     8,X
        STB     1,X
        LDA     <$F1
        CLRB
        LDY     <$8A
        LDU     #$0009
        JSR     >DDosFWrite
        BEQ     LD5BE
LD5BB   JMP     >LC69E

LD5BE   LDA     <$F1
        LDB     #$09
        LDX     $0652
        LDU     $0654
        LDY     <$8A
        JSR     >DDosFWrite
        BNE     LD5BB
        CLR     <$F6
        RTS

CmdChain   JSR     >LD6CE
        LBNE    LD6F8
        JSR     >LD46C
        LBNE    LC69E
        CMPA    #$01
        LBNE    LD431
        JSR     >LD669
        LDD     4,X
        STD     $0656
        ADDD    <$19
        SUBD    <$1B
        PSHS    D
        ADDD    <$1F
        STD     <$1F
        LDB     #$40
        JSR     >$8331
        LDD     ,S
        BPL     LD611
        LDX     <$1B
        LEAU    D,X
LD606   LDA     ,X+
        STA     ,U+
        CMPU    <$1F
        BLS     LD606
        BRA     LD61F

LD611   LDX     <$1F
        LEAX    1,X
        LEAU    D,X
LD617   LDA     ,-X
        STA     ,-U
        CMPX    <$1B
        BCC     LD617
LD61F   LDD     ,S
        ADDD    <$1B
        STD     <$1B
        PULS    D
        ADDD    <$1D
        STD     <$1D
        LDU     <$1F
        LDY     <$1D
        JSR     <$A5
        BEQ     LD652
        LDB     #$2C
        JSR     >$89AC
        JSR     >$869A
        JSR     >$8424
        STU     <$1F
        STY     <$1D
        LDY     $0656
        JSR     >LD4ED
        LDD     <$2B
        JSR     >$85E7
        BRA     LD661

LD652   JSR     >$841F
        STU     <$1F
        STY     <$1D
        LDY     $0656
        JSR     >LD4ED
LD661   LDB     #$01
        STB     $0611
        JMP     >LD4CE

LD669   LDU     <$A6
        PSHS    X,U
        LDX     <$1B
        LEAX    2,X
LD671   CMPX    <$1D
        BCC     LD67F
        TST     -1,X
        BPL     LD67B
        BSR     LD6AD
LD67B   LEAX    7,X
        BRA     LD671

LD67F   LDU     <$1D
LD681   CMPU    <$1F
        BCC     LD6A5
        LDD     2,U
        LEAX    D,U
        PSHS    X
        TST     1,U
        BPL     LD6A1
        LDB     4,U
        CLRA
        ASLB
        LEAX    D,U
        LEAX    5,X
LD698   JSR     >LD6AD
        LEAX    5,X
        CMPX    ,S
        BCS     LD698
LD6A1   PULS    U
        BRA     LD681

LD6A5   JSR     >$8CD7
        PULS    X,U
        STU     <$A6
        RTS

LD6AD   PSHS    X,U
        CMPX    <$21
        BCC     LD6C6
        LDB     ,X
        BEQ     LD6C6
        JSR     >$8CB3
        TFR     X,U
        LDY     ,S
        LDX     2,Y
        STU     2,Y
        JSR     >$B7CC
LD6C6   PULS    X,U,PC

LD6C8   LDY     #DDF8A
        BRA     LD6D8

LD6CE   LDY     #DDF87
        BRA     LD6D8

LD6D4   LDY     #DDF90
LD6D8   PSHS    Y
        JSR     >$8887
        JSR     >$8877
        PULS    Y
LD6E2   LDX     <$52
        PSHS    X
        LDB     ,X
        LDX     2,X
        JSR     >LC7B7
        PULS    X
        PSHS    D
        JSR     >$8D9F
        PULS    D
        TSTB
        RTS

LD6F8   JMP     >LC69E

LD6FB   LDA     #$0A
        STA     <$F1
LD6FF   JSR     >LCED3
        BNE     LD71D
        DEC     <$F1
        BPL     LD6FF
LD708   CLR     <$F6
LD70A   RTS

LD70B   BLE     LD70A
        LDX     ,S
        CMPX    #$B7EE
        BNE     LD70A
        LEAS    2,S
        STB     <$EB
        JSR     >DDosCloseAll
        BEQ     LD708
LD71D   JMP     >LC69E

LD720   BSR     LD6FB
        JMP     >LDB27

CmdCreate   JSR     >LD6C8
        BEQ     LD732
        CMPB    #$9E
        BEQ     LD732
        CMPB    #$A0
        BNE     LD71D
LD732   LDA     <$F1
        JSR     >DDosCreateFile
        BNE     LD71D
        JSR     <$A5
        BEQ     LD773
        JSR     >$89AA
        JSR     >$8887
        JSR     >LD884
LD746   TST     <$51
        BEQ     LD75C
        LDD     #$FF00
        BSR     LD76E
        LDD     <$52
        SUBD    #$FF00
        STD     <$52
        BCC     LD746
        DEC     <$51
        BNE     LD746
LD75C   LDD     <$52
        BEQ     LD70A
        CMPD    #$FF00
        BLS     LD76E
        SUBD    #$FF00
        BSR     LD76E
        LDD     #$FF00
LD76E   JSR     >LCBEC
        BNE     LD71D
LD773   RTS

CmdKill   JSR     >LD6D4
        BNE     LD77E
        JSR     >DDosDeleteFile
        BEQ     LD708
LD77E   JMP     >LC69E

;
; Protect/unprotect a file.
;

DDosProtect   
		TSTA
        BPL     LD78E
        CMPA    #$C2
        BEQ     LD7A0
        CMPA    #$88
        LBNE    BasicSNErr
LD78E   BSR     LD798
        LDB     #$01
LD792   JSR     >LD09D
        BNE     LD77E
        RTS

LD798   JSR     <$9F
        JSR     >LD6D4
        BNE     LD7C4
        RTS

LD7A0   BSR     LD798
        CLRB
        BRA     LD792

;
; Rename a file.
;

DDosRename   
		JSR     >LD6D4
        BNE     LD7C4
        PSHS    A
        LDB     #$BC
        JSR     >$89AC
        JSR     >LD6D4
        BEQ     LD7C2
        CMPB    #$A0
        BNE     LD7C4
        PULS    A
        JSR     >LD0CF
        BNE     LD7C4
        RTS

LD7C2   LDB     #$9E
LD7C4   JMP     >LC69E

CmdFLRead   BSR     LD7D6
        LDA     #$FF
        STA     $0612
        JSR     >LD969
        BSR     >LD803
        JMP     >$9DD9

LD7D6   JSR     >LD6C8
        BNE     LD82D
        JSR     >LD830
        JSR     >LCEAC
        TST     $067E
        BEQ     LD7F0
        LDU     $0664
        LDB     $0666
        STU     12,X
        STB     14,X
LD7F0   JSR     >LD9DC
        LDX     #$02DC
        CLR     ,X
        JSR     <$9F
        RTS

CmdFRead   BSR     LD7D6
        CLR     $0612
        JSR     >$877A
LD803   JSR     >LCEAC
        LDB     $0604
        BEQ     LD819
        CLR     $0603
        LDD     13,X
        SUBD    $0603
        STD     13,X
        BCC     LD819
        DEC     12,X
LD819   TST     <$F4
        BEQ     LD82A
        LDB     <$F3
        BEQ     LD82A
        CLRA
        ADDD    13,X
        STD     13,X
        BCC     LD82A
        INC     12,X
LD82A   CLR     <$6F
LD82C   RTS

LD82D   JMP     >LC69E

LD830   JSR     >$9C76
        LDA     <$F1
        JSR     >DDosGetFlen
        BNE     LD82D
        STU     $0664
        STA     $0666
        CLR     <$F4
        CLR     $067E
        LDA     #$01
        STA     <$6F
LD849   JSR     <$A5
        CMPA    #$3B
        BEQ     LD82C
        JSR     >$89AA
        CMPA    #$E5
        BNE     LD86A
        JSR     <$9F
        JSR     >$8887
        BSR     LD884
        STU     $0664
        STA     $0666
        LDA     #$FF
        STA     $067E
        BRA     LD849

LD86A   CMPA    #$80
        BNE     LD87B
        JSR     <$9F
        JSR     >LC63F
        STB     <$F3
        LDB     #$FF
        STB     <$F4
        BRA     LD849

LD87B   JMP     >BasicSNErr

LD87E   JMP     >$8B8D

LD881   JMP     >$8882

LD884   TST     <$54
        BMI     LD87E
        TST     <$06
        BNE     LD881
        LDA     #$A0
        SUBA    <$4F
        BEQ     LD89D
LD892   LSR     <$50
        ROR     <$51
        ROR     <$52
        ROR     <$53
        DECA
        BNE     LD892
LD89D   LDU     <$51
        LDA     <$53
        RTS

LD8A2   JMP     >LC69E

CmdFWrite   JSR     >LD6C8
        BEQ     LD8B3
        CMPB    #$A0
        BNE     LD8A2
        JSR     >DDosCreateFile
        BNE     LD8A2
LD8B3   JSR     >LD830
        JSR     >LD274
        BNE     LD8A2
        STX     $060B
        LDA     #$55
        STA     2,X
        CLR     <$F2
        JSR     <$9F
        JSR     >$903D
        TST     <$F4
        BEQ     LD8D8
        LDB     <$F3
        BEQ     LD8D8
        LDA     #$20
LD8D3   BSR     LD91D
        DECB
        BNE     LD8D3
LD8D8   TST     <$F2
        BEQ     LD8F4
        LDX     $060B
        LDX     5,X
        CLRA
        LDB     <$F2
        TFR     D,U
        LDA     <$F1
        LDY     $0664
        LDB     $0666
        JSR     >DDosFWrite
        BNE     LD8A2
LD8F4   LDX     $060B
        CLR     2,X
LD8F9   RTS

LD8FA   BLE     LD8F9
        CMPB    #$04
        BHI     LD914
        PULS    X,PC

LD902   LEAS    2,S
        JSR     >$8887
        JSR     >$8DEA
        PSHS    B
        JSR     >$B7D4
        TSTB
        LBLE    $B835
LD914   JMP     >$B851

LD917   TST     <$6F
        BLE     LD8F9
        LEAS    2,S
LD91D   PSHS    D,X,Y,U
        LDB     <$F4
        BEQ     LD927
        LDB     <$F3
        BEQ     LD95E
LD927   LDX     $060B
        LDX     5,X
        LDB     <$F2
        ABX
        STA     ,X
        DEC     <$F3
        INC     <$F2
        BNE     LD95E
        LDA     <$F1
        LDX     $060B
        LDX     5,X
        LDU     #$0100
        LDY     $0664
        LDB     $0666
        JSR     >DDosFWrite
        BEQ     LD950
        JMP     >LC69E

LD950   LDD     $0665
        ADDD    #$0100
        BCC     LD95B
        INC     $0664
LD95B   STD     $0665
LD95E   PULS    D,X,Y,U,PC

LD960   TST     <$6F
        BLE     LD8F9
        LDX     #$879A
        STX     ,S
LD969   LDA     <$F4
        BEQ     LD971
        LDA     <$F3
        BEQ     LD9BE
LD971   LDX     #$02DD
        LDB     <$F2
        STB     $0603
        ABX
        LDB     $0604
        STB     $0611
        CLRB
        STB     -1,X
        STB     <$00
LD985   DEC     <$F3
        DEC     $0604
        INC     <$F2
        LDA     ,X+
        BEQ     LD9BE
        CMPA    #$0D
        BEQ     LD9BE
        TST     $0612
        BNE     LD9A1
        CMPA    #$2C
        BEQ     LD9BE
        CMPA    #$3A
        BEQ     LD9BE
LD9A1   LDA     <$F4
        BEQ     LD9A9
        LDA     <$F3
        BEQ     LD9BE
LD9A9   INCB
        CMPB    #$FF
        BEQ     LD9BC
        LDA     $0604
        BNE     LD985
        LDB     <$00
        BNE     LD9BC
        BSR     LD9C8
        CLRB
        BRA     LD985

LD9BC   LEAX    1,X
LD9BE   LDB     $0603
        CLR     -1,X
        LDX     #$02DC
        ABX
        RTS

LD9C8   JSR     >LCEAC
        CLRA
        LDB     $0611
        NOP
        PSHS    D
        LDD     13,X
        SUBD    ,S++
        STD     13,X
        BCC     LD9DC
        DEC     12,X
LD9DC   PSHS    Y,U
        LDU     #$00FF
        BSR     LDA01
        LDU     #$02DD
        CLR     D,U
        LDA     <$F1
        LDB     14,X
        LDX     12,X
        EXG     X,U
        JSR     >DDosFRead
        BNE     LD9FE
        LDX     #$02DD
        CLR     -1,X
        PULS    Y,U,PC

LD9FC   LDB     #$9A
LD9FE   JMP     >LC69E

LDA01   PSHS    U
        LDD     13,X
        ADDD    ,S
        PSHS    D
        LDA     12,X
        ADCA    #$00
        SUBA    $10,X
        PULS    D
        BCS     LDA26
        BHI     LD9FC
        SUBD    $11,X
        BLS     LDA26
        LDD     $11,X
        SUBD    13,X
        BEQ     LD9FC
        STD     ,S
        COM     <$00
LDA26   LDD     ,S
        STB     $0604
        STB     $0611
        CLR     $0603
        CLR     <$F2
        PULS    Y,PC

CmdDir   BEQ     LDA3C
        JSR     >LC68F
        BRA     LDA3F

LDA3C   LDB     $060A
LDA3F   STB     <$EB
        CLR     ,-S
        CLRB
LDA44   JSR     >$851B
        JSR     >DDosGetDirEntry
        LBNE    LC69E
        LDA     ,X
        BITA    #$08
        BNE     LDA9A
        BITA    #$81
        BNE     LDA92
        LEAX    1,X
        LDB     #$08
        BSR     LDAAA
        LDA     #$2E
        JSR     >$B54A
        LDB     #$03
        BSR     LDAAA
        LDA     -12,X
        BITA    #$02
        BEQ     LDA70
        LDA     #$70
LDA70   EQU     *+1
        CMPX    #$8620
        JSR     >$B54A
        JSR     >$90F5
        LDU     #$FFFF
        LDX     #$06BD
        LDB     ,S
        STB     $1D,X
        JSR     >LCAF9
        LBNE    LC69E
        JSR     >LCE99
        BSR     LDAB7
        JSR     >$90A1
LDA92   INC     ,S
        LDB     ,S
        CMPB    #$B4
        BCS     LDA44
LDA9A   PULS    A
        JSR     >DDosGetFree
        CLRA
        TFR     X,U
        BSR     LDAB7
        LDX     #DDACD
        JMP     >BasicPrintStr

LDAAA   LDA     ,X+
        BNE     LDAB0
        LDA     #$20
LDAB0   JSR     >$B54A
        DECB
        BNE     LDAAA
        RTS

LDAB7   STU     <$51
        STA     <$53
        CLR     <$54
        CLR     <$50
        CLR     <$63
        LDA     #$A0
        STA     <$4F
        JSR     >$9165
        JSR     >$9587
DDACD   EQU     *+2
        JMP     >BasicPrintStr

        FCC     / FREE BYTES/
        FCB     $0D
        FCB     $0D
        FCB     $00

CmdAuto   LDD     <$68
        CMPD    #$FFFF
        BEQ     LDAE7
        JMP     >$8B8D

LDAE7   LDD     #$0064
        PSHS    D
        LDB     #$0A
        PSHS    D
        JSR     <$A5
        BEQ     LDB12
        JSR     >$8E83
        LDD     <$52
        STD     2,S
        JSR     <$A5
        BEQ     LDB12
        JSR     >$89AA
        JSR     >$8E83
        LDD     <$52
        BEQ     LDB0F
        STD     ,S
        JSR     <$A5
        BEQ     LDB12
LDB0F   JMP     >BasicSNErr

LDB12   ORCC    #$50
        LDD     ,S++
        STD     $060F
        LDD     ,S++
        SUBD    $060F
        STD     $060D
        LDA     #$FF
        STA     $0613
        RTS

LDB27   PSHS    D,X,U
        TST     $0613
        BNE     LDB30
LDB2E   PULS    D,X,U,PC

LDB30   LDD     $060D
        ADDD    $060F
        CMPD    #$F9FF
        BHI     LDB2E
        STD     ,S
        JSR     $957A
        LDA     #$20
        JSR     $B54A
        LDU     #$03DA
        LDD     ,S
        STD     $060D
        LDX     #$02DD
        LDB     #$00
LDB53   LDA     ,U+
        BEQ     LDB5C
        STA     ,X+
        INCB
        BRA     LDB53

LDB5C   LDA     #$20
        STA     ,X+
        INCB
LDB61   JSR     $B505
        CMPA    #$0D
        BEQ     LDB6C
        CMPA    #$03
        BNE     LDB82
LDB6C   CLR     $0613
        LDA     #$0D
        JSR     $B54A
        LEAS    8,S
        CLR     <$85
        LDX     #$02DD
        LDA     #$0D
        LDB     #$01
        JMP     >$B5D3

LDB82   CMPA    #$20
        BCS     LDB61
        CMPA    #$7B
        BCC     LDB61
        LEAS    8,S
        CLR     <$85
LDB90   EQU     *+2
        JMP     >$B5D3

LDB91   CLRA
        LDX     #$0008
LDB95   JSR     $BE12
        LEAX    -1,X
        BNE     LDB95
LDB9C   RTS

CmdBeep   
		BEQ     LDBA3
        JSR     LC63F
LDBA3   EQU     *+1
        CMPX    #DC601
        PSHS    B
        CLRB
        JSR     $BAED
LDBAB   JSR     LDB91
        JSR     $851B
        DEC     ,S
        BEQ     LDBBF
        LDY     #$6000
LDBB9   LEAY    -1,Y
        BEQ     LDBAB
        BRA     LDBB9

LDBBF   PULS    B,PC

CmdWait   BEQ     LDB9C
        JSR     $8E83
        LDX     <$52
LDBC8   JSR     $851B
        LDB     #$A0
LDBCD   DECB
        BNE     LDBCD
        LEAX    -1,X
        BNE     LDBC8
        RTS

CmdSwap   JSR     $8A94
        LDX     <$39
        LDA     <$06
        PSHS    A,X
        JSR     $89AA
        JSR     $8A94
        PULS    A,Y
        CMPA    <$06
        LBNE    $8882
        LDU     <$39
        LDX     #$0005
LDBF1   LDA     ,U
        LDB     ,Y
        STB     ,U+
        STA     ,Y+
        LEAX    -1,X
        BNE     LDBF1
        RTS

LDBFE   LDB     #$8E
LDC00   JMP     >LC69E


;
; If assembling for the DragonDos cartrage, this is the dispatch for
; the boot command, if assembling for the dragon Alpha, I have used
; the space occupied by the boot command to store the code used to
; activate the Alpha's drive selects and motor on, this is reasonable
; because the Alpha has a graphical boot menu, which allows it to boot
; from disk, so this routine seemed expendable.
;

		ifne	DragonAlpha

; Translate DragonDos Drive select mechinisim to work on Alpha 
; Takes byte that would be output to $FF48, reformats it and 
; outputs to Alpha AY-8912's IO port, which is connected to 
; Drive selects, motor on and enable precomp.
; We do not need to preserve the ROM select bit as this code
; operates in RAM only mode.


AlphaDskCtl	
		PSHS	x,A,B,CC,DP

		pshs	a			; Convert drives
		anda	#%00000011	; mask out drive number
		leax	ADriveTab,pcr	; point at table
		lda		a,x			; get bitmap
		ldb		,s
		andb	#%11111100	; mask out drive number
		stb		,s
		ora		,s			; recombine

		bita	#MotorOn	; test motor on ?
		bne		MotorRunning

		clra				; No, turn off other bits.
MotorRunning
		anda	#KnownBits	; Mask out bits we do not know the function of
		sta		,s
		
		lda		#AYIOREG	; AY-8912 IO register
		sta		PIA2DB		; Output to PIA
		ldb		#AYREGLatch	; Latch register to modify
		stb		PIA2DA
		
		clr		PIA2DA		; Idle AY
		
		lda		,s+			; Fetch saved Drive Selects
		sta		PIA2DB		; output to PIA
		ldb		#AYWriteReg	; Write value to latched register
		stb		PIA2DA		; Set register

		clr		PIA2DA		; Idle AY
				
		PULS	dp,x,A,B,CC,pc

		else
;		
; Boot command dispatch routine (DragonDos only).
;

CmdBoot   
	BEQ     LDC0A
        JSR     LC68F
        BRA     LDC0D

LDC0A   LDB     $060A
LDC0D   LDA     #$03
        STA     <$ED
        STB     <$EB
        LBSR    LC165
        BCS     LDC00
        LBSR    LC15F
        BCS     LDC00
        LDD     #$4F53
        CMPD    <$4F
        BNE     LDBFE
        LDD     #$2600
        STD     <$EE
LDC2A   JSR     DoReadAbsSector
        BCS     LDC00
        INC     <$EE
        INC     <$ED
        LDA     <$ED
        CMPA    #$12
        BLS     LDC2A
        JMP     >$2602

		ENDC
		
;
;Drive command dispatch routine.
;

CmdDrive
	BEQ     LDC46
        JSR     LC68F
        STB     $060A
        JMP     <$9F

LDC46   JMP     >BasicSNErr

CmdError   
	CMPA    #$81
        BNE     LDC46
        JSR     <$9F
        CMPA    #$BC
        BNE     LDC46
        JSR     <$9F
        JSR     $869A
        LDX     <$2B
        CMPX    #$F9FF
        LBHI    $8B8D
        STX     $0615
        BEQ     LDC6C
        LDA     #$FF
        STA     $0614
        RTS

LDC6C   CLR     $0614
        RTS

LDC70   JSR     $89AA
        JSR     $8A94
        JMP     >$8877

CmdSread   LBSR    LDD1A
        BSR     LDC70
        PSHS    X
        BSR     LDC70
        PSHS    X
        LDB     #$FF
        STB     <$F6
        JSR     LD274
        BNE     LDCB1
        CLR     2,X
        LDX     5,X
        STX     <$EE
        JSR     DoReadAbsSector
        STB     $0603
        LDU     <$EE
        LEAU    $0080,U
        PULS    X
        BSR     LDCB4
        LDU     <$EE
        PULS    X
        BSR     LDCB4
        CLR     <$F6
        LDB     $0603
        BNE     LDCB1
        RTS

LDCB1   JMP     >LC69E

LDCB4   PSHS    X,U
        LDB     #$80
        JSR     $8C52
        LEAU    ,X
        PULS    X
        STB     ,X
        STU     2,X
        PULS    X
        JMP     >$B7CC

CmdSwrite   BSR     LDD1A
        BSR     LDD14
        JSR     $8877
        LDX     <$52
        PSHS    X
        BSR     LDD14
        JSR     $8D9A
        PSHS    B,X
        LDB     #$FF
        STB     <$F6
        JSR     LD274
        BNE     LDCB1
        CLR     2,X
        LDX     5,X
        STX     <$EE
        CLRB
LDCEA   CLR     ,X+
        DECB
        BNE     LDCEA
        PULS    B,X
        LDU     <$EE
        LEAU    $0080,U
        TSTB
        BEQ     LDCFD
        JSR     $B7CC
LDCFD   PULS    X
        JSR     $8D9F
        LDU     <$EE
        TSTB
        BEQ     LDD0A
        JSR     $B7CC
LDD0A   JSR     LC101
        LBCS    LC69E
        CLR     <$F6
        RTS

LDD14   JSR     $89AA
        JMP     >$8887

LDD1A   BNE     LDD1F
        JMP     >BasicSNErr

LDD1F   JSR     LC68F
        STB     <$EB
        JSR     $8E7E
        CMPB    #$4F
        BHI     LDD33
        STB     <$EC
        JSR     $8E7E
        STB     <$ED
LDD32   RTS

LDD33   JMP     >$8B8D

CmdVerify   BEQ     LDD46
        CMPA    #$C2
        BNE     LDD3F
        CLRB
        BRA     LDD48

LDD3F   CMPA    #$88
        BEQ     LDD46
        JMP     >BasicSNErr

LDD46   LDB     #$FF
LDD48   STB     $0608
        JMP     <$9F

LDD4D   TST     <$06
        BEQ     LDD32
        CLR     <$06
        LEAS    2,S
        LDY     #DDF8A
        JSR     LD6E2
        BNE     LDD77
        JSR     DDosGetFlen
        BNE     LDD77
        JSR     LCEAC
        CMPU    12,X
        BHI     LDD6F
        CMPA    14,X
        BLS     LDD71
LDD6F   CLRA
LDD71   EQU     *+1
        CMPX    #$8601
        LDU     <$8A
        BRA     LDD92

LDD77   JMP     >LC69E

FuncFres   JSR     LD6C8
        BNE     LDD77
        JSR     LCEAC
        LDU     12,X
        LDA     14,X
        BRA     LDD92

FuncLof   JSR     LD6C8
        BNE     LDD77
        JSR     DDosGetFlen
        BNE     LDD77
LDD92   CLR     <$06
        STA     <$53
        STU     <$51
        CLR     <$50
        CLR     <$63
        LDA     #$A0
        STA     <$4F
        JMP     >$9165

FuncFree   JSR     <$A5
        BEQ     LDDAC
        JSR     LC68F
        BRA     LDDAF

LDDAC   LDB     $060A
LDDAF   STB     <$EB
        JSR     DDosGetFree
        BNE     LDD77
        TFR     X,U
        CLRA
        BRA     LDD92

FuncErl   LDD     $0617
LDDBE   JMP     >$8C37

FuncErr   CLRA
        LDB     $0619
        BRA     LDDBE

FuncHimem   LDD     <$27
        BRA     LDDBE

LDDCB   JSR     $8CD7
        LDD     <$23
        SUBD    <$21
        BRA     LDDBE

DDDD4   FDB     LC2A1
        FDB     LC2A7
        FDB     LC2D3
;LDDDB   EQU     *+1
        FDB     LC33E
        FDB     LC33B
        FDB     LC361
        FDB     LC2D0
        FDB     LC2FB
DDDE4   FDB     $010A	; Sector layout table for format ?
        FDB     $020B
        FDB     $030C
        FDB     $040D
        FDB     $050E
        FDB     $060F
        FDB     $0710
        FDB     $0811
        FDB     $0912
DDDF7   EQU     *+1
        FDB     $0035
        FDB     $4E4E
        FDB     $0800
        FDB     $0003
        FDB     $F6FC
        FDB     $1F4E
DDE03   EQU     *+1
        FDB     $4E07
        FDB     $0000
        FDB     $03F5
        FDB     $FE01
        FDB     $F74E
        FDB     $144E
        FDB     $4E0B
        FDB     $0000
        FDB     $03F5
        FDB     $FB00
        FDB     $E5F7
        FDB     $174E
        FDB     $4E00
        FDB     $4E4E
DDE1E   FCB     $09
        FDB     $0109
        JMP     >LC6F7

        JMP     >LC700

        JMP     >LC7B0

        FCB     $04
        FDB     $069F
        FCB     $02
        FCB     $02
        FCB     $02
        FCB     $02
        FCB     $1E
        FDB     $012A
        FCB     $1A
        FDB     DDED4
        FDB     LC64C
        FCB     $07
        FDB     DDEBB
        FDB     LC667
        FCB     $00
        FDB     $0000
        FDB     BasicSNErr
        FCB     $00
        FDB     $0000
        FDB     BasicSNErr
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00

CommandDispatchTable   
		FDB     CmdAuto
        FDB     CmdBackup
        FDB     CmdBeep

		ifne	DragonAlpha
		FDB		BasicSNErr	; If assembling for Alpha, just redirect to ?SN error
		else
        FDB     CmdBoot		; Else, if dragondos, boot command 
		endc

        FDB     CmdChain
        FDB     CmdCopy
        FDB     CmdCreate
        FDB     CmdDir
        FDB     CmdDrive
        FDB     CmdDskInit
        FDB     CmdFRead
        FDB     CmdFWrite
        FDB     CmdError
        FDB     CmdKill
        FDB     CmdLoad
        FDB     CmdMerge
        FDB     DDosProtect
        FDB     CmdWait
        FDB     DDosRename
        FDB     CmdSave
        FDB     CmdSread
        FDB     CmdSwrite
        FDB     CmdVerify
        FDB     BasicSNErr
        FDB     CmdFLRead
        FDB     CmdSwap
		
FunctionDipatchTable   
		FDB     FuncLof
        FDB     FuncFree
        FDB     FuncErl
        FDB     FuncErr
        FDB     FuncHimem
        FDB     FuncFres
DDE93   FDB     LDDCB
DDE95   FDB     LD902
DDE97   FDB     LD8FA
DDE99   FDB     DC27E
DDE9B   FDB     LD917
DDE9D   FDB     DC27E
DDE9F   FDB     DC27E
DDEA1   FDB     DC27E
DDEA3   FDB     DC27E
DDEA5   FDB     LD6FB
DDEA7   FDB     DC27E
DDEA9   FDB     LD960
DDEAB   FDB     DC27E
		FDB		LD720
		FDB		DC27E
		FDB		LDD4D
		FDB		DC27E
		FDB		DC27E
		FDB		LC69E
		FDB		LD490
DDEBB   FCB     $4C
        FCB     $4F
        FCB     $C6
        FCC     /FRE/
        FCB     $C5
        FCB     $45
        FCB     $52
        FCB     $CC
        FCB     $45
        FCB     $52
        FCB     $D2
        FCC     /HIME/
        FCB     $CD
        FCB     $4C
        FCB     $4F
        FCB     $C3
        FCC     /FRE/
        FCB     $A4
DDED4   FCC     /AUT/
        FCB     $CF
        FCC     /BACKU/
        FCB     $D0
        FCC     /BEE/
        FCB     $D0
        FCC     /BOO/
        FCB     $D4
        FCC     /CHAI/
        FCB     $CE
        FCC     /COP/
        FCB     $D9
        FCC     /CREAT/
        FCB     $C5
        FCB     $44
        FCB     $49
        FCB     $D2
        FCC     /DRIV/
        FCB     $C5
        FCC     /DSKINI/
        FCB     $D4
        FCC     /FREA/
        FCB     $C4
        FCC     /FWRIT/
        FCB     $C5
        FCC     /ERRO/
DDF13   FCB     $D2
        FCC     /KIL/
        FCB     $CC
        FCC     /LOA/
        FCB     $C4
        FCC     /MERG/
        FCB     $C5
        FCC     /PROTEC/
        FCB     $D4
        FCC     /WAI/
        FCB     $D4
        FCC     /RENAM/
        FCB     $C5
        FCC     /SAV/
        FCB     $C5
        FCC     /SREA/
        FCB     $C4
        FCC     /SWRIT/
        FCB     $C5
        FCC     /VERIF/
        FCB     $D9
        FCC     /FRO/
        FCB     $CD
        FCC     /FLREA/
        FCB     $C4
        FCC     /SWA/
        FCB     $D0
        FCC     /INSERT SOURCE/
        FCB     $0D
        FCB     $00
        FCC     /INSERT DESTINATION/
        FCB     $0D
DDF77   FCB     $00
        FCC     /PRESS ANY KEY/
        FCB     $0D
        FCB     $00
DDF87   FCC     /BAS/
DDF8A	FCC		/DAT/
DDF8D	FCC		/BIN/
DDF90	FCC		/   NRSKWPRTRFCCLDBTIVFDDFFSPTPEF/


		FCC     /FFENETFPR?/
		
		IFNE	DragonAlpha
DDFBA	FCC		/?ALPHA-DOS 1.0d/
		ELSE
DDFBA	FCC		/?DRAGONDOS 1.0d/
		ENDC
		
        FCB     $0D
        FCB     $0D
;        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00

; Set PIAs, called with X=FF01 or X=FF21

LDFD2   LDA     ,X
        PSHS    A
        STB     ,X++
        LDA     ,X
        PSHS    A
        STB     ,X
        LDX     #PIA1CRA
        TFR     U,PC

LDFE3   LDX     #$FF25
DDFE6   PULS    A
        STA     ,--X
        PULS    A
        STA     ,--X
        LDX     #$FF05
        TFR     U,PC

		IFNE	DragonAlpha
ADriveTab
		FCB		Drive0,Drive1,Drive2,Drive3
		ELSE
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
		ENDC
		
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00
        FCB     $00

;DE000   END
